"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var redux_effects_promise_1 = require("redux-effects-promise");
var index_1 = require("../definition/index");
var ConnectorActionBuilder = /** @class */ (function () {
    function ConnectorActionBuilder() {
    }
    /**
     * @stable [19.12.2019]
     * @param {string} section
     * @returns {IEffectsAction}
     */
    ConnectorActionBuilder.buildInitPlainAction = function (section) {
        return { type: this.buildInitActionType(section) };
    };
    /**
     * @stable [19.12.2019]
     * @param {string} section
     * @returns {IEffectsAction}
     */
    ConnectorActionBuilder.buildDestroyPlainAction = function (section) {
        return { type: this.buildDestroyActionType(section) };
    };
    /**
     * @stable [20.10.2018]
     * @param {string} section
     * @returns {string}
     */
    ConnectorActionBuilder.buildInitActionType = function (section) {
        return index_1.$RAC_CONNECTED_CONTAINER_INIT_ACTION_TYPE + "." + section;
    };
    /**
     * @stable [25.11.2019]
     * @param {string} section
     * @returns {string}
     */
    ConnectorActionBuilder.buildInitErrorActionType = function (section) {
        return redux_effects_promise_1.EffectsActionBuilder.buildErrorActionType(this.buildInitActionType(section));
    };
    /**
     * @stable [20.10.2018]
     * @param {string} section
     * @returns {string}
     */
    ConnectorActionBuilder.buildDestroyActionType = function (section) {
        return index_1.$RAC_CONNECTED_CONTAINER_DESTROY_ACTION_TYPE + "." + section;
    };
    return ConnectorActionBuilder;
}());
exports.ConnectorActionBuilder = ConnectorActionBuilder;
//# sourceMappingURL=connector-action.builder.js.map