"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var di_1 = require("../../di");
exports.isButtonDisabled = function (entity) { return entity.disabled || entity.progress; };
exports.getButtonText = function (entity) {
    var settings = di_1.getSettings();
    return (entity.progress
        ? (entity.progressMessage || settings.messages.waitingMessage)
        : (entity.error
            ? entity.errorMessage || settings.messages.defaultErrorMessage
            : entity.text));
};
exports.getButtonIcon = function (entity, progressIcon, errorIcon) { return (entity.progress
    ? progressIcon
    : (entity.error ? errorIcon : entity.icon)); };
exports.hasIconButton = function (props) { return !R.isNil(props.icon) && props.icon !== false; };
//# sourceMappingURL=button.support.js.map