import * as React from 'react';
import { IActivateDialogConfigEntity, IDialog, IDialogProps, IDialogState } from '../../definition';
import { BaseComponent } from '../base/base.component';
export declare class BaseDialog<TProps extends IDialogProps = IDialogProps, TState extends IDialogState = IDialogState> extends BaseComponent<TProps, TState> implements IDialog<TProps, TState> {
    private static readonly DIALOG_CLASS_NAME;
    private static readonly DIALOG_SCRIM_CLASS_NAME;
    private static readonly DIALOG_SCRIM_SELECTOR;
    private static readonly DIALOG_SELECTOR;
    private onDeactivateCallback;
    private closeEventUnsubscriber;
    private readonly doesAnotherScrimLayerExist;
    private readonly bodyRef;
    /**
     * @stable [06.01.2020]
     * @param {TProps} props
     */
    constructor(props: TProps);
    /**
     * @stable [25.01.2020]
     * @returns {React.ReactNode}
     */
    render(): React.ReactNode;
    /**
     * @stable [25.01.2020]
     */
    componentWillUnmount(): void;
    /**
     * @stable [24.01.2020]
     * @param {IActivateDialogConfigEntity} payload
     */
    activate(payload?: IActivateDialogConfigEntity): void;
    /**
     * @stable [06.01.2020]
     */
    accept(): void;
    /**
     * @stable [06.01.2020]
     */
    protected onAcceptClick(): void;
    /**
     * @stable [05.01.2020]
     */
    private onCloseClick;
    /**
     * @stable [05.01.2020]
     */
    private onDialogScrimClick;
    /**
     * @stable [25.01.2020]
     */
    private onDocumentClickCapture;
    /**
     * @stable [25.01.2020]
     */
    private onAfterRender;
    /**
     * @stable [05.01.2020]
     * @param {() => void} callback
     */
    private doClose;
    /**
     * @stable [24.03.2019]
     * @returns {JSX.Element}
     */
    private readonly footerElement;
    /**
     * @stable [24.01.2020]
     * @returns {JSX.Element}
     */
    private readonly dialogBodyElement;
    /**
     * @stable [06.01.2020]
     * @returns {JSX.Element}
     */
    private readonly bodyElement;
    /**
     * @stable [25.01.2020]
     */
    private unsubscribeEvents;
    /**
     * @stable [06.01.2020]
     * @returns {boolean}
     */
    private readonly acceptable;
    /**
     * @stable [06.01.2020]
     * @returns {boolean}
     */
    private readonly closable;
    /**
     * @stable [06.01.2020]
     * @returns {boolean}
     */
    private readonly isCloseButtonDisabled;
    /**
     * @stable [06.01.2020]
     * @returns {boolean}
     */
    private readonly isAcceptButtonDisabled;
    /**
     * @stable [15.01.2020]
     * @returns {Element}
     */
    private readonly portalElement;
    /**
     * @stable [24.01.2020]
     * @returns {boolean}
     */
    private readonly isAnchored;
    /**
     * @stable [05.01.2020]
     * @returns {string}
     */
    private readonly dialogClassName;
}
