/// <reference types="react" />
import { IApiEntity, IForm, IFormProps } from '../../definition';
import { BaseComponent } from '../base';
export declare class Form extends BaseComponent<IFormProps> implements IForm {
    static defaultProps: IFormProps;
    private fieldsOptions;
    private readonly formRef;
    /**
     * @stable [29.05.2018]
     * @param {IFormProps} props
     */
    constructor(props: IFormProps);
    render(): JSX.Element;
    /**
     * @stable [12.09.2018]
     */
    componentDidMount(): void;
    /**
     * @stable - 11.04.2018
     * @param {IApiEntity} apiEntity
     */
    submit(apiEntity: IApiEntity): void;
    /**
     * @stable [23.12.2019]
     * @returns {IApiEntity}
     */
    readonly apiEntity: IApiEntity;
    /**
     * @stable [25.02.2019]
     * @returns {string}
     */
    private getFormClassName;
    private onChange;
    /**
     * @stable [04.08.2018]
     * @param {IField} field
     */
    private onEmptyDictionary;
    private onLoadDictionary;
    /**
     * @stable [03.12.2019]
     */
    private propsOnValid;
    private doSubmit;
    private onSubmit;
    private onReset;
    /**
     * @stable [03.08.2018]
     * @returns {boolean}
     */
    private isFormValid;
    /**
     * @stable [03.08.2018]
     * @returns {boolean}
     */
    private isFormSubmittable;
    /**
     * @stable [15.02.2019]
     * @returns {boolean}
     */
    private isFormResettable;
    /**
     * @stable [25.02.2019]
     * @returns {boolean}
     */
    private isFormOfNewEntity;
    /**
     * @stable [25.09.2019]
     * @returns {boolean}
     */
    private isFormBusy;
    /**
     * @stable [25.09.2019]
     * @param {IField} field
     * @returns {boolean}
     */
    private isFieldReadOnly;
    /**
     * @stable - 11.04.2018
     * @param {IField} field
     * @returns {boolean}
     */
    private isFieldDisabled;
    /**
     * @stable [16.11.2018]
     * @param {IField} field
     * @returns {boolean}
     */
    private isFieldChangeable;
    /**
     * @stable [16.11.2019]
     * @param {IField} field
     * @returns {AnyT}
     */
    private getFieldValue;
    /**
     * @stable [16.11.2019]
     * @param {IField} field
     * @returns {AnyT}
     */
    private getFieldOriginalValue;
    /**
     * @stable [24.12.2019]
     * @param {IFieldProps} props
     * @param {IFieldProps} defaultProps
     * @returns {AnyT}
     */
    private getFieldDisplayValue;
    /**
     * @stable [11.09.2019]
     * @param {IField} field
     * @returns {IFieldProps}
     */
    private getPredefinedFieldProps;
    /**
     * @stable - 01.04.2018
     * @returns {IEntity}
     */
    private readonly form;
    /**
     * @stable [25.02.2019]
     * @returns {JSX.Element}
     */
    private readonly formActionsWrapperElement;
    /**
     * @stable [25.02.2019]
     * @returns {JSX.Element}
     */
    private readonly formActionsElement;
}
