/// <reference types="react" />
import { LayoutContainer } from '../layout.container';
import { IDefaultLayoutContainerProps, IDefaultLayoutContainerState } from './default-layout.interface';
export declare class DefaultLayoutContainer extends LayoutContainer<IDefaultLayoutContainerProps, IDefaultLayoutContainerState> {
    static readonly defaultProps: IDefaultLayoutContainerProps;
    private readonly userExitActionValue;
    private readonly userMenuAnchorRef;
    private readonly userMenuRef;
    private readonly userProfileActionValue;
    private readonly userMenuProps;
    private readonly navigationMenuBuilder;
    /**
     * @stable [18.09.2018]
     * @param {IDefaultLayoutContainerProps} props
     */
    constructor(props: IDefaultLayoutContainerProps);
    /**
     * @stable [18.09.2018]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [18.09.2018]
     * @param {IBaseEvent} event
     */
    private onUserMenuActionClick;
    /**
     * @stable [18.09.2018]
     * @param {IMenuItemEntity} menuItem
     */
    private onUserMenuSelect;
    /**
     * @stable [18.09.2018]
     * @param {IStringMenuActionEntity} option
     */
    private onHeaderMoreOptionsSelect;
    /**
     * @stable [17.10.2018]
     */
    private onLogoMenuActionClick;
    /**
     * @stable [18.09.2018]
     */
    private onHeaderNavigationActionClick;
    /**
     * @stable [23.12.2019]
     * @param {IXYEntity} xy
     */
    private onNavigationListScroll;
    /**
     * @stable [23.09.2018]
     * @param {INavigationItemEntity} item
     */
    private onNavigationListGroupClick;
    /**
     * @stable [23.09.2018]
     * @returns {boolean}
     */
    private readonly layoutFullModeEnabled;
    /**
     * @stable [23.09.2018]
     * @returns {LayoutModeEnum}
     */
    private readonly layoutMode;
    /**
     * @stable [18.09.2018]
     * @returns {INavigationItemEntity[]}
     */
    private readonly menuItems;
    /**
     * @stable [18.09.2018]
     * @returns {JSX.Element}
     */
    private readonly headerElement;
    /**
     * @stable [18.09.2018]
     * @returns {JSX.Element}
     */
    private readonly drawerElement;
    /**
     * @stable [04.12.2019]
     */
    private onProfileMenuClick;
    /**
     * @stable [08.10.2018]
     * @returns {JSX.Element}
     */
    private readonly mainElement;
    /**
     * @stable [08.10.2018]
     * @returns {JSX.Element}
     */
    private readonly footerElement;
    /**
     * @stable [18.03.2019]
     * @returns {JSX.Element}
     */
    private readonly mainProgressOverlayElement;
    /**
     * @stable [11.02.2019]
     * @returns {JSX.Element}
     */
    private readonly notificationsElement;
    /**
     * @stable [24.01.2020]
     * @returns {JSX.Element}
     */
    private readonly userMenuElement;
    /**
     * @stable [24.01.2020]
     * @returns {HTMLElement}
     */
    private getMenuAnchorElement;
    private readonly navigationListElement;
}
