"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var util_1 = require("../../../util");
var list_1 = require("../../list");
var base_1 = require("../../base");
var definition_1 = require("../../../definition");
var ListItem = /** @class */ (function (_super) {
    __extends(ListItem, _super);
    /**
     * @stable [27.10.2019]
     * @param {IListItemProps} props
     */
    function ListItem(props) {
        var _this = _super.call(this, props) || this;
        _this.onClick = _this.onClick.bind(_this);
        return _this;
    }
    /**
     * @stable [23.09.2019]
     * @returns {JSX.Element}
     */
    ListItem.prototype.render = function () {
        var _this = this;
        var props = this.props;
        return (React.createElement(definition_1.UniversalScrollableContext.Consumer, null, function (selectedElementClassName) { return (props.renderer
            ? React.cloneElement(props.renderer(props.rawData, props.index), _this.getItemProps({ selectedElementClassName: selectedElementClassName }))
            : (React.createElement("li", __assign({}, _this.getItemProps({ selectedElementClassName: selectedElementClassName })),
                props.icon && React.createElement(list_1.ListItemGraphic, { iconConfiguration: props.icon }),
                util_1.isFn(props.tpl)
                    ? React.createElement(list_1.ListItemText, null, props.tpl(props.rawData))
                    : props.children))); }));
    };
    /**
     * @stable [27.10.2019]
     * @param {ISelectedElementClassNameWrapper} context
     * @returns {React.DetailedHTMLProps<React.LiHTMLAttributes<HTMLLIElement>, HTMLLIElement>}
     */
    ListItem.prototype.getItemProps = function (context) {
        var props = this.props;
        return (__assign({ ref: this.selfRef, className: util_1.joinClassName.apply(void 0, ['rac-list-item',
                props.className,
                props.odd && 'rac-list-item-odd'].concat((util_1.isSelected(props)
                ? ['rac-list-item-selected', context.selectedElementClassName]
                : ['rac-list-item-unselected']))) }, util_1.handlerPropsFactory(this.onClick, !util_1.isDisabled(props) && util_1.isFn(props.onClick), false)));
    };
    /**
     * @stable [27.10.2019]
     */
    ListItem.prototype.onClick = function () {
        var props = this.props;
        props.onClick(props.rawData);
    };
    return ListItem;
}(base_1.BaseComponent));
exports.ListItem = ListItem;
//# sourceMappingURL=list-item.component.js.map