/// <reference types="react" />
import { INavigationListProps } from './navigation-list.interface';
import { IScrollableEntity } from '../../../definition';
import { UniversalComponent } from '../../base/universal.component';
export declare class NavigationList extends UniversalComponent<INavigationListProps> implements IScrollableEntity {
    /**
     * @stable [24.10.2019]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [24.10.2019]
     */
    onScroll(): void;
    /**
     * @stable [23.09.2018]
     * @param {INavigationItemEntity} item
     * @returns {JSX.Element}
     */
    private toElement;
    /**
     * @stable [23.09.2018]
     * @param {INavigationItemEntity} config
     */
    private onGroupLinkClick;
    /**
     * @stable [23.09.2018]
     * @param {string} link
     * @param {string} prefix
     * @returns {string}
     */
    private toUniqueKey;
    /**
     * @stable [23.09.2018]
     * @param {INavigationItemEntity} item
     * @returns {boolean}
     */
    private isItemExpanded;
    /**
     * @stable [23.09.2018]
     * @returns {boolean}
     */
    private readonly fullLayoutModeEnabled;
    /**
     * @stable [23.09.2018]
     * @param {INavigationItemEntity} item
     * @returns {boolean}
     */
    private hasActiveChild;
}
