"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var action_builder_1 = require("../../../action.builder");
var base_store_proxy_1 = require("../base-store.proxy");
var FormStoreProxy = /** @class */ (function (_super) {
    __extends(FormStoreProxy, _super);
    /**
     * @stable [09.10.2019]
     * @param {IUniversalContainer<TProps extends IUniversalContainerProps>} container
     */
    function FormStoreProxy(container) {
        var _this = _super.call(this, container) || this;
        _this.container = container;
        _this.dispatchFormReset = _this.dispatchFormReset.bind(_this);
        return _this;
    }
    /**
     * @stable [09.10.2019]
     * @param {string} otherSection
     */
    FormStoreProxy.prototype.dispatchFormReset = function (otherSection) {
        this.dispatchAnyAction(action_builder_1.FormActionBuilder.buildResetPlainAction(otherSection || this.sectionName));
    };
    /**
     * @stable [09.10.2019]
     * @param {TChanges} changes
     * @param {string} otherSection
     */
    FormStoreProxy.prototype.dispatchFormChanges = function (changes, otherSection) {
        this.dispatchAnyAction(action_builder_1.FormActionBuilder.buildChangesPlainAction(otherSection || this.sectionName, changes));
    };
    return FormStoreProxy;
}(base_store_proxy_1.BaseStoreProxy));
exports.FormStoreProxy = FormStoreProxy;
//# sourceMappingURL=form-store.proxy.js.map