"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var redux_effects_promise_1 = require("redux-effects-promise");
var tabpanel_interface_1 = require("./tabpanel.interface");
var util_1 = require("../../util");
var TabPanelActionBuilder = /** @class */ (function () {
    function TabPanelActionBuilder() {
    }
    /**
     * @stable [30.08.2018]
     * @param {string} section
     * @returns {string}
     */
    TabPanelActionBuilder.buildActivateActionType = function (section) {
        return util_1.toActionPrefix(section) + "." + tabpanel_interface_1.TAB_PANEL_ACTIVE_VALUE_ACTION_TYPE;
    };
    /**
     * @stable [30.08.2018]
     * @param {string} section
     * @returns {string}
     */
    TabPanelActionBuilder.buildDestroyActionType = function (section) {
        return util_1.toActionPrefix(section) + "." + tabpanel_interface_1.TAB_PANEL_DESTROY_ACTION_TYPE;
    };
    /**
     * @stable [30.08.2018]
     * @param {string} section
     * @returns {IEffectsAction}
     */
    TabPanelActionBuilder.buildDestroyAction = function (section) {
        return redux_effects_promise_1.EffectsAction.create(this.buildDestroyActionType(section), util_1.applySection(section));
    };
    return TabPanelActionBuilder;
}());
exports.TabPanelActionBuilder = TabPanelActionBuilder;
//# sourceMappingURL=tabpanel-action.builder.js.map