"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var util_1 = require("../../../util");
var configurations_definitions_interface_1 = require("../../../configurations-definitions.interface");
var delayed_changes_field_plugin_1 = require("../../field/field/plugin/delayed-changes-field.plugin");
var universal_component_1 = require("../../base/universal.component");
var UniversalSearchToolbar = /** @class */ (function (_super) {
    __extends(UniversalSearchToolbar, _super);
    /**
     * @stable [18.05.2018]
     * @param {TProps} props
     */
    function UniversalSearchToolbar(props) {
        var _a;
        var _this = _super.call(this, props) || this;
        /**
         * @stable [18.05.2018]
         */
        _this.baseActionsProps = (_a = {},
            _a[configurations_definitions_interface_1.ToolbarActionEnum.OPEN_FILTER] = {
                type: 'filter',
                onClick: _this.onOpen.bind(_this),
            },
            _a[configurations_definitions_interface_1.ToolbarActionEnum.CLEAR_FILTER] = {
                type: 'close',
                onClick: _this.onDeactivate.bind(_this),
            },
            _a[configurations_definitions_interface_1.ToolbarActionEnum.REFRESH_DATA] = { type: 'refresh', title: _this.settings.messages.refreshActionTitleMessage },
            _a[configurations_definitions_interface_1.ToolbarActionEnum.DOWNLOAD_DATA] = { type: 'download', title: _this.settings.messages.exportActionTitleMessage },
            _a);
        _this.onActivate = _this.onActivate.bind(_this);
        _this.onApply = _this.onApply.bind(_this);
        _this.onChange = _this.onChange.bind(_this);
        _this.onActionClick = _this.onActionClick.bind(_this);
        return _this;
    }
    Object.defineProperty(UniversalSearchToolbar.prototype, "isActive", {
        /**
         * @stable [18.05.2018]
         * @returns {boolean}
         */
        get: function () {
            return this.props.active;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UniversalSearchToolbar.prototype, "query", {
        /**
         * @stable [18.05.2018]
         * @returns {string}
         */
        get: function () {
            return this.props.query;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @stable [18.05.2018]
     */
    UniversalSearchToolbar.prototype.onActivate = function () {
        var props = this.props;
        if (props.notUseField) {
            // Invoke a search
            this.onApply();
        }
        else {
            if (props.onActivate) {
                // Open a search field
                props.onActivate();
            }
        }
    };
    /**
     * @stable [18.05.2018]
     */
    UniversalSearchToolbar.prototype.onDeactivate = function () {
        var props = this.props;
        if (props.onDeactivate) {
            // Close a search field
            props.onDeactivate();
        }
    };
    /**
     * @stable [18.05.2018]
     * @param {string} query
     */
    UniversalSearchToolbar.prototype.onChange = function (query) {
        var props = this.props;
        if (props.onChange) {
            props.onChange(query);
        }
    };
    Object.defineProperty(UniversalSearchToolbar.prototype, "fieldProps", {
        /**
         * @stable [18.05.2018]
         * @returns {IUniversalFieldProps}
         */
        get: function () {
            var props = this.props;
            return __assign({ ref: 'queryField', autoFocus: true, errorMessageRendered: false, value: this.query, actions: this.actions, onChange: this.onChange, onDelay: this.onApply, plugins: delayed_changes_field_plugin_1.DelayedChangesFieldPlugin }, props.fieldConfiguration);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UniversalSearchToolbar.prototype, "actions", {
        // TODO
        get: function () {
            var _this = this;
            var props = this.props;
            var defaultActions = props.notUseField
                ? []
                : [{ type: configurations_definitions_interface_1.ToolbarActionEnum.CLEAR_FILTER }];
            return R.map(function (action) {
                var config = _this.baseActionsProps[action.type];
                return (__assign({}, config, { onClick: util_1.isFn(config.onClick) ? config.onClick : (function () { return _this.onActionClick(action.type); }), disabled: util_1.nvl(action.disabled, props.actionsDisabled), className: action.className }));
            }, defaultActions.concat(props.actions));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UniversalSearchToolbar.prototype, "actionsElements", {
        /**
         * @stable [18.05.2018]
         * @returns {JSX.Element[]}
         */
        get: function () {
            var _this = this;
            var actions;
            var props = this.props;
            return []
                .concat(this.isActive
                ? []
                : this.getActionElement({
                    key: 'toolbar-action-key',
                    icon: props.icon,
                    onClick: this.onActivate,
                    disabled: props.actionsDisabled,
                })).concat(props.notUseField && (actions = this.actions).length > 0
                ? actions.map(function (action, index) { return _this.getActionElement(__assign({}, action, { icon: action.type, key: "toolbar-action-key-" + index, disabled: props.actionsDisabled, className: action.className })); })
                : []);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UniversalSearchToolbar.prototype, "fieldSection", {
        /**
         * @stable [18.05.2018]
         * @returns {JSX.Element}
         */
        get: function () {
            var _this = this;
            return util_1.orNull(this.isActive, function () { return _this.fieldWrapper; });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UniversalSearchToolbar.prototype, "actionsElementsSection", {
        /**
         * @stable [18.05.2018]
         * @returns {JSX.Element}
         */
        get: function () {
            var _this = this;
            return util_1.orNull(this.actionsElements.length > 0, function () { return _this.actionsElementsWrapper; });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UniversalSearchToolbar.prototype, "queryField", {
        /**
         * @stable [18.05.2018]
         * @returns {IUniversalField}
         */
        get: function () {
            return this.refs.queryField;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @stable [18.05.2018]
     */
    UniversalSearchToolbar.prototype.onOpen = function () {
        var props = this.props;
        if (props.onOpen) {
            props.onOpen();
        }
    };
    /**
     * @stable [18.05.2018]
     */
    UniversalSearchToolbar.prototype.onApply = function () {
        var props = this.props;
        if (props.onApply) {
            props.onApply();
        }
    };
    /**
     * @stable [12.09.2018]
     * @param {ToolbarActionEnum} type
     */
    UniversalSearchToolbar.prototype.onActionClick = function (type) {
        var props = this.props;
        if (props.onActionClick) {
            props.onActionClick(type);
        }
    };
    /**
     * @stable [18.05.2018]
     */
    UniversalSearchToolbar.defaultProps = {
        actions: [],
        icon: 'search',
        fieldConfiguration: {
            placeholder: 'Search',
        },
    };
    return UniversalSearchToolbar;
}(universal_component_1.UniversalComponent));
exports.UniversalSearchToolbar = UniversalSearchToolbar;
//# sourceMappingURL=universal-search-toolbar.component.js.map