import { IDataWrapper, IDictionariesWrapper, IKeyValue, ILoadingWrapper, IPlacesWrapper } from '../definitions.interface';
import { IPagedEntity } from './page-definition.interface';
/**
 * @stable [10.09.2019]
 */
export declare const DEFAULT_DICTIONARY_PAGE_SIZE = 300;
/**
 * @stable [04.12.2019]
 */
export declare const INITIAL_DICTIONARIES_ENTITY: Readonly<IDictionariesEntity>;
/**
 * @stable [04.12.2019]
 */
export declare const $RAC_DICTIONARIES_DESTROY_ACTION_TYPE: string;
export declare const DICTIONARY_LOAD_ACTION_TYPE = "dictionary.load";
export declare const DICTIONARY_SET_ACTION_TYPE = "dictionary.set";
/**
 * @stable [11.01.2020]
 */
export declare enum DictionariesEnum {
    PLACES = "places"
}
/**
 * @stable [10.09.2019]
 */
export declare const DEFAULT_DICTIONARY_PAGED_ENTITY: Readonly<IPagedEntity>;
/**
 * @stable [10.10.2019]
 */
export interface IDictionaryEntity<TData = IKeyValue> extends IDataWrapper<TData[] | TData>, ILoadingWrapper {
}
/**
 * @stable [11.01.2020]
 */
export interface IPlacesDictionaryWrapperEntity extends IPlacesWrapper<IDictionaryEntity<{}>> {
}
/**
 * @stable [14.01.2020]
 */
export interface IBaseDictionariesEntity extends IPlacesDictionaryWrapperEntity {
}
/**
 * @stable [10.10.2019]
 */
export interface IDictionariesEntity extends IBaseDictionariesEntity {
    [dictionary: string]: IDictionaryEntity<{}>;
}
/**
 * @stable [10.10.2019]
 */
export interface IDictionariesWrapperEntity extends IDictionariesWrapper<IDictionariesEntity> {
}
