import { IButtonProps } from './button-definition.interface';
/**
 * @stable [09.10.2019]
 */
export declare enum RegexpEnum {
    PRICE = "\\d+(\\.\\d{1,2})?",
    NUMBER = "[-+]?[0-9]*[.,]?[0-9]+",
    DIGITAL = "[0-9]+"
}
/**
 * @stable [09.10.2019]
 */
export declare const REGEXP: {
    DIGITAL: RegExp;
    PRICE: RegExp;
};
/**
 * @stable [25.12.2019]
 */
export interface IDateTimeSettingsEntity {
    currentDate?: Date;
    dateTimeFormat?: string;
    maxDate?: Date;
    minDate?: Date;
    uiDateFormat?: string;
    uiDateMask?: Array<string | RegExp>;
    uiDatePattern?: string;
    uiDefaultTime?: string;
    uiTimeFormat?: string;
    uiYearFormat?: string;
    uiYearMask?: Array<string | RegExp>;
    uiYearPattern?: string;
}
/**
 * @stable [25.12.2019]
 */
export declare const DEFAULT_DATE_TIME_SETTINGS_ENTITY: Readonly<IDateTimeSettingsEntity>;
/**
 * @stable [29.11.0219]
 */
export interface ICurrencySettingsEntity {
    uiLocale?: string;
    uiCurrency?: string;
    uiShortCurrency?: string;
}
/**
 * @stable [15.10.2019]
 */
export declare const DEFAULT_CURRENCY_SETTINGS_ENTITY: Readonly<ICurrencySettingsEntity>;
/**
 * @entity
 * @stable [09.01.2020]
 */
export interface IAsyncLibrariesSettingsEntity {
    googleMaps?: string;
}
/**
 * @entity
 * @stable [24.01.2020]
 */
export interface IComponentsSettingsEntity {
    button?: IButtonProps;
}
/**
 * @default-entity
 * @stable [09.01.2020]
 */
export declare const DEFAULT_ASYNC_LIBRARIES_SETTINGS_ENTITY: Readonly<IAsyncLibrariesSettingsEntity>;
/**
 * @stable [10.01.2020]
 */
export interface IGoogleMapsSettingsEntity {
    componentRestrictions?: {
        country?: string;
    };
    lat?: number;
    libraries?: string;
    lng?: number;
    prettyZoom?: number;
    zoom?: number;
}
/**
 * @default-entity
 * @stable [10.01.2020]
 */
export declare const DEFAULT_GOOGLE_MAPS_SETTINGS_ENTITY: Readonly<IGoogleMapsSettingsEntity>;
/**
 * @stable [29.11.0219]
 */
export interface IPhoneSettingsEntity {
    countryAbbr?: string;
    uiMask?: Array<string | RegExp>;
}
/**
 * @stable [29.11.0219]
 */
export declare const DEFAULT_PHONE_SETTINGS_ENTITY: Readonly<IPhoneSettingsEntity>;
/**
 * @stable [07.10.2019]
 */
export interface IMessagesSettingsEntity {
    ADDRESS_SELECTION?: string;
    APPLICATION_IS_INITIALIZING?: string;
    APPLY?: string;
    BUILD?: string;
    CLEAR_ALL?: string;
    CLOSE?: string;
    DETAILS_INFO?: string;
    DIALOG_ACCEPT?: string;
    DIALOG_CANCEL?: string;
    ENVIRONMENT?: string;
    ERROR?: string;
    FILTER_PLACEHOLDER?: string;
    FILTERS?: string;
    MONTH?: string;
    NEW_APP_VERSION_HAS_BEEN_DEPLOYED?: string;
    OK?: string;
    PATH?: string;
    PLEASE_WAIT?: string;
    PLS_SEND_THIS_SCR_TO_SUPPORT_MANAGER?: string;
    PUT_MARKER_HERE?: string;
    QUARTER?: string;
    RESTART_APP?: string;
    SOMETHING_WENT_WRONG?: string;
    UNKNOWN_ERROR?: string;
    USER?: string;
    WEEK?: string;
    YEAR?: string;
}
/**
 * @stable [07.10.2019]
 */
export declare const DEFAULT_MESSAGES_SETTINGS_ENTITY: Readonly<IMessagesSettingsEntity>;
