"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @stable [09.10.2019]
 */
var RegexpEnum;
(function (RegexpEnum) {
    RegexpEnum["PRICE"] = "\\d+(\\.\\d{1,2})?";
    RegexpEnum["NUMBER"] = "[-+]?[0-9]*[.,]?[0-9]+";
    RegexpEnum["DIGITAL"] = "[0-9]+";
})(RegexpEnum = exports.RegexpEnum || (exports.RegexpEnum = {}));
/**
 * @stable [09.10.2019]
 */
exports.REGEXP = {
    DIGITAL: new RegExp(RegexpEnum.DIGITAL),
    PRICE: new RegExp(RegexpEnum.PRICE),
};
/**
 * @stable [25.12.2019]
 */
var defaultDateTimeSettingsEntity = {
    dateTimeFormat: 'YYYY-MM-DD[T]HH:mm:ssZ',
    maxDate: new Date('01/01/4000'),
    minDate: new Date('01/01/1900'),
    uiDateFormat: 'YYYY-MM-DD',
    uiDateMask: [/\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/, '-', /\d/, /\d/],
    uiDatePattern: '[0-9]{4}-(0[1-9]|1[0-2])-(0[1-9]|[1-2][0-9]|3[0-1])',
    uiDefaultTime: '00:00:00',
    uiTimeFormat: 'HH:mm:ss',
    uiYearFormat: 'YYYY',
    uiYearMask: [/\d/, /\d/, /\d/, /\d/],
    uiYearPattern: '[0-9]{4}',
};
Reflect.defineProperty(defaultDateTimeSettingsEntity, 'currentDate', {
    get: function () { return new Date(); },
});
/**
 * @stable [25.12.2019]
 */
exports.DEFAULT_DATE_TIME_SETTINGS_ENTITY = Object.freeze(defaultDateTimeSettingsEntity);
/**
 * @stable [15.10.2019]
 */
exports.DEFAULT_CURRENCY_SETTINGS_ENTITY = Object.freeze({
    uiLocale: 'en-US',
    uiCurrency: 'USD',
    uiShortCurrency: '$',
});
/**
 * @default-entity
 * @stable [09.01.2020]
 */
exports.DEFAULT_ASYNC_LIBRARIES_SETTINGS_ENTITY = Object.freeze({
    googleMaps: 'https://maps.googleapis.com/maps/api/js',
});
/**
 * @default-entity
 * @stable [10.01.2020]
 */
exports.DEFAULT_GOOGLE_MAPS_SETTINGS_ENTITY = Object.freeze({
    componentRestrictions: { country: 'us' },
    lat: 34.0522,
    libraries: 'places,visualization',
    lng: -118.2436,
    prettyZoom: 17,
    zoom: 13,
});
/**
 * @stable [29.11.0219]
 */
exports.DEFAULT_PHONE_SETTINGS_ENTITY = Object.freeze({
    countryAbbr: 'US',
    uiMask: ['+', /\d/, '(', /\d/, /\d/, /\d/, ')', /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/],
});
/**
 * @stable [07.10.2019]
 */
exports.DEFAULT_MESSAGES_SETTINGS_ENTITY = Object.freeze({
    ADDRESS_SELECTION: 'Address selection',
    APPLICATION_IS_INITIALIZING: 'The app is initializing...',
    APPLY: 'Apply',
    BUILD: 'Build',
    CLEAR_ALL: 'Clear all',
    CLOSE: 'Close',
    DETAILS_INFO: 'Details info',
    DIALOG_ACCEPT: 'Continue',
    DIALOG_CANCEL: 'Cancel',
    ENVIRONMENT: 'Environment',
    ERROR: 'Error',
    FILTER_PLACEHOLDER: 'Search',
    FILTERS: 'Filters',
    MONTH: 'Month',
    NEW_APP_VERSION_HAS_BEEN_DEPLOYED: 'The app has been updated! Let\'s go to the main page',
    OK: 'Ok',
    PATH: 'Path',
    PLEASE_WAIT: 'Please wait...',
    PLS_SEND_THIS_SCR_TO_SUPPORT_MANAGER: 'Please send this screenshot to your support manager',
    PUT_MARKER_HERE: 'Put marker here',
    QUARTER: 'Quarter',
    RESTART_APP: 'Restart App',
    SOMETHING_WENT_WRONG: 'Something went wrong',
    UNKNOWN_ERROR: 'Unknown error',
    USER: 'User',
    WEEK: 'Week',
    YEAR: 'Year',
});
//# sourceMappingURL=settings-definition.interface.js.map