import { Store } from 'redux';
import { INumberConverter, IDateConverter } from '../converter';
import { ISettingsEntity } from '../settings';
import { DialogFormChangesConfirmStoreProxyFactoryT, FormStoreProxyFactoryT, IAsyncLibManager, IAuth, IConnectorEntity, IEnvironment, IEventEmitter, IEventManager, IFieldConverter, ILogManager, IModifyEntityPayloadFactory, IPermissionsManager, IPhoneConverter, IPlaceApi, IStateSerializer, IStorage, IStoreEntity, ITransport, IUniversalComponentCtor, IUniversalComponentProps, IUniversalConnectorContainerFactory, IUniversalContainerCtor, IUniversalContainerProps, IUserActivityManager, RouterStoreProxyFactoryT, UniversalPluginFactoryT } from '../definition';
import { IUIFactory } from '../component/factory/factory.interface';
import { TranslatorT } from '../translation';
/**
 * @stable [31.10.2018]
 * @returns {INumberConverter}
 */
export declare const getNumberConverter: () => INumberConverter;
/**
 * @stable [24.12.2019]
 * @returns {IPhoneConverter}
 */
export declare const getPhoneConverter: () => IPhoneConverter<{}>;
/**
 * @stable [16.11.2019]
 * @returns {IPermissionsManager<TAccessConfig>}
 */
export declare const getPermissionsManager: <TAccessConfig = {}>() => IPermissionsManager<TAccessConfig, {}>;
/**
 * @stable [16.11.2019]
 * @returns {DynamicRoutesMapT}
 */
export declare const getDynamicRoutes: () => Map<IUniversalContainerCtor<IUniversalContainerProps<{}, {}>, {}, {}, {}>, IConnectorEntity<{}, {}>>;
/**
 * @stable [17.11.2019]
 * @returns {DynamicSectionsMapT}
 */
export declare const getDynamicSections: () => Map<string, IConnectorEntity<{}, {}>>;
/**
 * @stable [16.11.2019]
 * @returns {IAuth}
 */
export declare const getAuth: () => IAuth;
/**
 * @stable [07.10.2019]
 * @returns {IDateConverter}
 */
export declare const getDateConverter: () => IDateConverter<Date>;
/**
 * @stable [09.11.2018]
 * @returns {IUIFactory}
 */
export declare const getUiFactory: () => IUIFactory;
/**
 * @stable [23.10.2019]
 * @returns {Map<IUniversalComponentCtor, UniversalPluginFactoryT>}
 */
export declare const getUiPlugins: () => Map<IUniversalComponentCtor<IUniversalComponentProps, {}>, UniversalPluginFactoryT>;
/**
 * @stable [15.11.2018]
 * @returns {TranslatorT}
 */
export declare const getTranslator: () => TranslatorT;
/**
 * @stable [29.07.2019]
 * @returns {ISettingsEntity}
 */
export declare const getSettings: () => ISettingsEntity;
/**
 * @stable [29.07.2019]
 * @returns {IStorage}
 */
export declare const getDatabaseStorage: () => IStorage;
/**
 * @stable [11.09.2019]
 * @returns {Store<TState>}
 */
export declare const getStore: <TState>() => Store<TState>;
/**
 * @stable [15.09.2019]
 * @returns {ITransport}
 */
export declare const getTransport: () => ITransport;
/**
 * @stable [20.09.2019]
 * @returns {IEnvironment}
 */
export declare const getEnvironment: () => IEnvironment;
/**
 * @stable [17.01.2020]
 * @returns {IEventEmitter}
 */
export declare const getEventEmitter: () => IEventEmitter;
/**
 * @stable [24.09.2019]
 * @returns {IStorage}
 */
export declare const getStorage: () => IStorage;
/**
 * @stable [24.09.2019]
 * @returns {ILogManager}
 */
export declare const getLogManager: () => ILogManager;
/**
 * @stable [24.09.2019]
 * @returns {IEventManager}
 */
export declare const getEventManager: () => IEventManager;
/**
 * @stable [09.01.2020]
 * @returns {IAsyncLibManager}
 */
export declare const getAsyncLibManager: () => IAsyncLibManager;
/**
 * @stable [09.01.2020]
 * @returns {IPlaceApi}
 */
export declare const getPlaceApi: () => IPlaceApi;
/**
 * @stable [09.01.2020]
 * @returns {IFieldConverter}
 */
export declare const getFieldConverter: () => IFieldConverter;
/**
 * @stable [24.09.2019]
 * @returns {IEventManager}
 */
export declare const getStateSerializer: () => IStateSerializer<IStoreEntity<{}, {}>>;
/**
 * @stable [09.10.2019]
 * @returns {IModifyEntityPayloadFactory}
 */
export declare const getModifyEntityPayloadFactory: () => IModifyEntityPayloadFactory;
/**
 * @stable [27.11.2019]
 * @returns {(parent: IContainer) => }
 */
export declare const getDialogFormChangesConfirmStoreProxyFactory: () => DialogFormChangesConfirmStoreProxyFactoryT;
/**
 * @stable [30.11.2019]
 * @returns {FormStoreProxyFactoryT}
 */
export declare const getFormStoreProxyFactory: () => FormStoreProxyFactoryT;
/**
 * @stable [18.12.2019]
 * @returns {RouterStoreProxyFactoryT}
 */
export declare const getRouterStoreProxyFactoryFactory: () => RouterStoreProxyFactoryT;
/**
 * @stable [19.12.2019]
 * @returns {IUniversalConnectorContainerFactory}
 */
export declare const getConnectorContainerFactory: () => IUniversalConnectorContainerFactory;
/**
 * @stable [19.01.2020]
 * @returns {IUserActivityManager}
 */
export declare const getUserActivityManager: () => IUserActivityManager;
