"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("../util");
var action_1 = require("../action");
var definition_1 = require("../definition");
/**
 * @stable [12.01.2020]
 * @param {IDictionariesEntity} state
 * @param {IEffectsAction} action
 * @returns {IDictionariesEntity}
 */
exports.dictionariesReducer = function (state, action) {
    if (state === void 0) { state = definition_1.INITIAL_DICTIONARIES_ENTITY; }
    var _a, _b, _c, _d;
    var section = util_1.toSection(action);
    var actionData = util_1.selectDataFromAction(action);
    switch (action.type) {
        case definition_1.$RAC_DICTIONARIES_DESTROY_ACTION_TYPE:
            return __assign({}, definition_1.INITIAL_DICTIONARIES_ENTITY);
        case action_1.DictionariesActionBuilder.buildLoadActionType(section):
            return __assign({}, state, (_a = {}, _a[section] = {
                data: null,
                loading: true,
            }, _a));
        case action_1.DictionariesActionBuilder.buildSetActionType(section):
            return __assign({}, state, (_b = {}, _b[section] = {
                data: actionData.data,
            }, _b));
        case action_1.DictionariesActionBuilder.buildLoadDoneActionType(section):
            return __assign({}, state, (_c = {}, _c[section] = {
                data: actionData,
                loading: false,
            }, _c));
        case action_1.DictionariesActionBuilder.buildLoadErrorActionType(section):
            return __assign({}, state, (_d = {}, _d[section] = __assign({}, state[section], { loading: false }), _d));
    }
    return state;
};
//# sourceMappingURL=dictionaries.reducer.js.map