"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var R = require("ramda");
var I18n = /** @class */ (function () {
    function I18n() {
    }
    I18n_1 = I18n;
    /**
     * @stable [23.02.2019]
     * @param {Record<string, string>} dualLanguagesMapper
     * @returns {string}
     */
    I18n.prototype.getCurrentLanguage = function (dualLanguagesMapper) {
        var nav = navigator;
        var language;
        // support for HTML 5.1 "navigator.languages"
        if (Array.isArray(nav.languages)) {
            nav.languages.forEach(function (lang) { return language = language || lang; });
        }
        // support for other well known properties in browsers
        I18n_1.browserLanguagePropertyKeys.forEach(function (browserLanguagePropertyKey) { return language = language || nav[browserLanguagePropertyKey]; });
        if (!R.isNil(language) && !R.isEmpty(language)) {
            var parts = language.split('-');
            if (!R.isNil(dualLanguagesMapper) && parts.length > 1) {
                return dualLanguagesMapper[language] || language;
            }
            return parts[0];
        }
        return language;
    };
    var I18n_1;
    I18n.browserLanguagePropertyKeys = [
        'language',
        'browserLanguage',
        'systemLanguage',
        'userLanguage'
    ];
    I18n = I18n_1 = __decorate([
        inversify_1.injectable()
    ], I18n);
    return I18n;
}());
exports.I18n = I18n;
//# sourceMappingURL=i18n.service.js.map