"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var definition_1 = require("../definition");
var error_1 = require("../error");
var notification_interface_1 = require("./notification.interface");
function notificationReducer(state, action) {
    if (state === void 0) { state = definition_1.INITIAL_NOTIFICATION_ENTITY; }
    switch (action.type) {
        case notification_interface_1.NOTIFICATION_INFO_ACTION_TYPE:
            return {
                info: action.data.info,
            };
        case notification_interface_1.NOTIFICATION_ERROR_ACTION_TYPE:
            return {
                error: error_1.convertError(action.data.error).message,
            };
        case notification_interface_1.NOTIFICATION_CLEAR_ACTION_TYPE:
            return __assign({}, definition_1.INITIAL_NOTIFICATION_ENTITY);
    }
    return state;
}
exports.notificationReducer = notificationReducer;
//# sourceMappingURL=notification.reducer.js.map