"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var env_1 = require("../env");
var util_1 = require("../util");
var definition_1 = require("../definition");
var StartDayOfWeekT;
(function (StartDayOfWeekT) {
    StartDayOfWeekT[StartDayOfWeekT["MONDAY"] = 0] = "MONDAY";
    StartDayOfWeekT[StartDayOfWeekT["SUNDAY"] = 1] = "SUNDAY";
})(StartDayOfWeekT = exports.StartDayOfWeekT || (exports.StartDayOfWeekT = {}));
exports.DEFAULT_APPLICATION_SETTINGS = {
    signalRUrl: util_1.prepareUrl(env_1.ENV.basePath + '/api/'),
    downloadUrl: util_1.prepareUrl(env_1.ENV.basePath + '/api/download/?params='),
    emptyPictureUrl: 'media/no_avatar.jpg',
    companyName: 'Test company',
    transport: {
        method: 'post',
        withCredentials: true,
        blobDataContentType: 'application/octet-stream',
        formDataContentType: 'multipart/form-data',
        apiUrl: util_1.prepareUrl(env_1.ENV.basePath + '/api/'),
        uploadUrl: util_1.prepareUrl(env_1.ENV.basePath + '/api/blobs/upload/'),
        uniqueParamName: '_dc',
    },
    messages: __assign({}, definition_1.DEFAULT_MESSAGES_SETTINGS_ENTITY, { acceptMessage: 'Accept', accessDeniedMessage: 'The access is restricted for you.', appNotReadyMessage: 'App is being initialized...', closeMessage: 'Close', confirmationMessage: 'Confirmation', continueMessage: 'Continue', create: 'Create', dataSaved: 'The data has been successfully saved.', defaultErrorMessage: 'Error', dialogTitleMessage: 'Notice', dndMessage: 'Upload a file(s) here', emptyDataMessage: 'No data found', emptyMessage: 'Start a search', errorMessage: 'Something went wrong. There was a problem loading your data', exportActionTitleMessage: 'Export', fileLoadErrorMessage: 'Can\'t load the file.', invalidAddressMessage: 'Invalid address', logOutMessage: 'Log out', logoutNotificationMessage: 'You were logged out.', noAvailableItemsToSelectMessage: 'No available items to select.', noItemsMessage: 'No items.', pagesMessage: '{from}-{to} of {count}', previewMessage: 'Preview', refreshActionTitleMessage: 'Refresh', requestCancelErrorMessage: 'The request has been canceled by the user.', reset: 'Reset', save: 'Save', serviceTemporarilyUnavailableMessage: 'Service temporarily unavailable. Please try later.', settingsMessage: 'Settings', simplePagesMessage: 'Page {page} of {count}', sorryMessage: 'Sorry about that.', takeSnapshotMessage: 'Take a snapshot', unknownFileMessage: 'Unknown file', waitingMessage: 'Waiting...', waitMessage: 'Please wait...', yearMessage: 'Year' }),
    asyncLibraries: definition_1.DEFAULT_ASYNC_LIBRARIES_SETTINGS_ENTITY,
    dateTime: __assign({}, definition_1.DEFAULT_DATE_TIME_SETTINGS_ENTITY, { startDayOfWeek: StartDayOfWeekT.MONDAY, dateFormat: 'YYYY-MM-DD', timeFormat: 'HH:mm:ss', uiMonthFormat: 'YYYY-MM', pstTimeFormat: 'hh:mm A', pstDateFormat: 'MMM DD', uiTimeMask: [/\d/, /\d/, ':', /\d/, /\d/, ':', /\d/, /\d/], uiShortTimeMask: [/\d/, /\d/, ':', /\d/, /\d/], uiTimePattern: '([0-1][0-9]|2[0-3]):([0-5][0-9]):([0-5][0-9])', uiShortTimePattern: '([0-1][0-9]|2[0-3]):([0-5][0-9])' }),
    bootstrap: {
        rootId: 'appId',
    },
    number: {
        uiPattern: definition_1.RegexpEnum.NUMBER,
    },
    phone: definition_1.DEFAULT_PHONE_SETTINGS_ENTITY,
    storage: definition_1.DEFAULT_STORAGE_SETTINGS_ENTITY,
    currency: definition_1.DEFAULT_CURRENCY_SETTINGS_ENTITY,
    channel: {
        eventToListen: 'client-event-to-listen',
        eventToEmit: 'client-event-to-emit',
    },
    authorization: {
        isAuthorizationNeeded: true,
    },
    googleMaps: definition_1.DEFAULT_GOOGLE_MAPS_SETTINGS_ENTITY,
};
// TODO Remove duplication
Reflect.defineProperty(exports.DEFAULT_APPLICATION_SETTINGS.dateTime, 'currentDate', {
    get: function () { return new Date(); },
});
//# sourceMappingURL=settings.interface.js.map