"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var redux_effects_promise_1 = require("redux-effects-promise");
var di_1 = require("../../di");
var action_builder_1 = require("../../component/action.builder");
var action_1 = require("../../action");
var middleware_1 = require("../middleware");
var middleware_2 = require("../middleware");
function makeFilteredListEffectsProxy(config) {
    var filterPath = config.filterPath, filterSection = config.filterSection, listSection = config.listSection;
    return function () {
        var Effects = /** @class */ (function () {
            function Effects() {
            }
            Effects_1 = Effects;
            /**
             * @stable [06.07.2018]
             * @param {IEffectsAction} action
             * @returns {IEffectsAction[]}
             */
            Effects.prototype.$onFilterManualApply = function (action) {
                return middleware_1.makeFilterManualApplyMiddleware({ listSection: listSection, action: action });
            };
            Effects.prototype.$onFilterApply = function () {
                return action_builder_1.ListActionBuilder.buildLoadAction(listSection);
            };
            // TODO Toolbar
            Effects.prototype.$onFilterRefresh = function (action) {
                return middleware_2.makeRefreshedListMiddleware({ listSection: listSection, action: action });
            };
            Effects.prototype.$onFilterDeactivate = function () {
                return (filterSection ? [action_builder_1.FormActionBuilder.buildDestroyAction(filterSection)] : []).concat([
                    action_builder_1.FilterActionBuilder.buildDestroyAction(listSection),
                    action_builder_1.ListActionBuilder.buildLoadAction(listSection)
                ]);
            };
            Effects.prototype.$onFilterOpen = function () {
                return [
                    action_1.StackActionBuilder.buildLockAction(filterSection),
                    action_1.RouterActionBuilder.buildNavigateAction(filterPath)
                ];
            };
            var Effects_1;
            __decorate([
                redux_effects_promise_1.EffectsService.effects(action_builder_1.FilterActionBuilder.buildManualApplyActionType(listSection)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object]),
                __metadata("design:returntype", Array)
            ], Effects.prototype, "$onFilterManualApply", null);
            __decorate([
                redux_effects_promise_1.EffectsService.effects(action_builder_1.FilterActionBuilder.buildApplyActionType(listSection)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Object)
            ], Effects.prototype, "$onFilterApply", null);
            __decorate([
                redux_effects_promise_1.EffectsService.effects(action_builder_1.ToolbarActionBuilder.buildCustomActionActionType(listSection)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object]),
                __metadata("design:returntype", Array)
            ], Effects.prototype, "$onFilterRefresh", null);
            __decorate([
                redux_effects_promise_1.EffectsService.effects(action_builder_1.FilterActionBuilder.buildDeactivateActionType(listSection)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Array)
            ], Effects.prototype, "$onFilterDeactivate", null);
            __decorate([
                redux_effects_promise_1.EffectsService.effects(action_builder_1.FilterActionBuilder.buildOpenActionType(listSection)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Array)
            ], Effects.prototype, "$onFilterOpen", null);
            Effects = Effects_1 = __decorate([
                di_1.provideInSingleton(Effects_1)
            ], Effects);
            return Effects;
        }());
    };
}
exports.makeFilteredListEffectsProxy = makeFilteredListEffectsProxy;
//# sourceMappingURL=filtered-list-effects.proxy.js.map