"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var redux_effects_promise_1 = require("redux-effects-promise");
var action_builder_1 = require("../../component/action.builder");
var di_1 = require("../../di");
function makePaginatedListEffectsProxy(section) {
    return function () {
        var Effects = /** @class */ (function () {
            function Effects() {
            }
            Effects_1 = Effects;
            Effects.prototype.$onPrevious = function () {
                return [
                    action_builder_1.ListActionBuilder.buildPreviousPageAction(section),
                    action_builder_1.ListActionBuilder.buildLoadAction(section)
                ];
            };
            Effects.prototype.$onNext = function () {
                return [
                    action_builder_1.ListActionBuilder.buildNextPageAction(section),
                    action_builder_1.ListActionBuilder.buildLoadAction(section)
                ];
            };
            Effects.prototype.$onFirst = function () {
                return [
                    action_builder_1.ListActionBuilder.buildFirstPageAction(section),
                    action_builder_1.ListActionBuilder.buildLoadAction(section)
                ];
            };
            Effects.prototype.$onLast = function () {
                return [
                    action_builder_1.ListActionBuilder.buildLastPageAction(section),
                    action_builder_1.ListActionBuilder.buildLoadAction(section)
                ];
            };
            var Effects_1;
            __decorate([
                redux_effects_promise_1.EffectsService.effects(action_builder_1.ToolbarActionBuilder.buildPagerPreviousActionType(section)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Array)
            ], Effects.prototype, "$onPrevious", null);
            __decorate([
                redux_effects_promise_1.EffectsService.effects(action_builder_1.ToolbarActionBuilder.buildPagerNextActionType(section)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Array)
            ], Effects.prototype, "$onNext", null);
            __decorate([
                redux_effects_promise_1.EffectsService.effects(action_builder_1.ToolbarActionBuilder.buildPagerFirstActionType(section)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Array)
            ], Effects.prototype, "$onFirst", null);
            __decorate([
                redux_effects_promise_1.EffectsService.effects(action_builder_1.ToolbarActionBuilder.buildPagerLastActionType(section)),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Array)
            ], Effects.prototype, "$onLast", null);
            Effects = Effects_1 = __decorate([
                di_1.provideInSingleton(Effects_1)
            ], Effects);
            return Effects;
        }());
    };
}
exports.makePaginatedListEffectsProxy = makePaginatedListEffectsProxy;
//# sourceMappingURL=paginated-list-effects.proxy.js.map