"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var util_1 = require("../../../../util");
var di_1 = require("../../../../di");
var TransportJsonRpcRequestDataFactory = /** @class */ (function () {
    function TransportJsonRpcRequestDataFactory() {
    }
    /**
     * @stable [16.09.2019]
     * @param {ITransportRequestEntity} req
     * @returns {ITransportJsonRpcRequestDataEntity}
     */
    TransportJsonRpcRequestDataFactory.prototype.makeRequestData = function (req) {
        var _this = this;
        var data = util_1.notNilValuesFilter({
            name: req.name,
            params: req.params && util_1.defValuesFilter(req.params),
            auth: util_1.ifNotTrueThanValue(req.noAuth, function () { return _this.tokenAccessor.token; }),
        });
        // Data with single id key, what for? Therefore, return null
        return util_1.ifNotEmptyThanValue(data, function () { return (__assign({}, data, { id: util_1.uuid() })); });
    };
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.TransportTokenAccessor),
        __metadata("design:type", Object)
    ], TransportJsonRpcRequestDataFactory.prototype, "tokenAccessor", void 0);
    TransportJsonRpcRequestDataFactory = __decorate([
        inversify_1.injectable()
    ], TransportJsonRpcRequestDataFactory);
    return TransportJsonRpcRequestDataFactory;
}());
exports.TransportJsonRpcRequestDataFactory = TransportJsonRpcRequestDataFactory;
//# sourceMappingURL=transport-json-rpc-request-data-factory.service.js.map