import { IFormExtendedEditableEntity, IFormProps, IGenericFieldEntity, IGenericFormEntity } from '../definition';
import { IEntity } from '../definitions.interface';
/**
 * @stable [16.11.2019]
 * @param {IFormExtendedEditableEntity<TEntity extends IEntity>} fEntity
 * @param {IGenericFieldEntity} fieldProps
 * @returns {AnyT}
 */
export declare const getFormFieldValue: <TEntity extends IEntity = IEntity>(fEntity: IFormExtendedEditableEntity<TEntity>, fieldProps: IGenericFieldEntity) => any;
/**
 * @stable [24.12.2019]
 * @param {IFormExtendedEditableEntity<TEntity extends IEntity>} fEntity
 * @param {IGenericFieldEntity} fieldProps
 * @param {IGenericFieldEntity} defaultFieldProps
 * @returns {AnyT}
 */
export declare const getFormFieldDisplayValue: <TEntity extends IEntity = IEntity>(fEntity: IFormExtendedEditableEntity<TEntity>, fieldProps: IGenericFieldEntity, defaultFieldProps?: IGenericFieldEntity) => any;
/**
 * @stable [16.11.2019]
 * @param {IFormExtendedEditableEntity<TEntity extends IEntity>} fEntity
 * @param {IGenericFieldEntity} fieldProps
 * @returns {AnyT}
 */
export declare const getFormFieldOriginalValue: <TEntity extends IEntity = IEntity>(fEntity: IFormExtendedEditableEntity<TEntity>, fieldProps: IGenericFieldEntity) => any;
/**
 * @stable [16.01.2020]
 * @param {IFormProps<TEntity extends IEntity>} entity
 * @returns {boolean}
 */
export declare const isFormEntityDisabled: <TEntity extends IEntity = IEntity>(entity: IFormProps<TEntity>) => boolean;
/**
 * @stable [16.01.2020]
 * @param {IFormProps<TEntity extends IEntity>} formEntity
 * @returns {boolean}
 */
export declare const isFormEntityDirty: <TEntity extends IEntity = IEntity>(formEntity: IFormProps<TEntity>) => boolean;
/**
 * @stable [16.01.2020]
 * @param {IFormProps<TEntity extends IEntity>} entity
 * @returns {boolean}
 */
export declare const isFormEntityValid: <TEntity extends IEntity = IEntity>(entity: IFormProps<TEntity>) => boolean;
/**
 * @stable [25.10.2019]
 * @param {IFormExtendedEditableEntity<TEntity extends IEntity>} entity
 * @returns {boolean}
 */
export declare const isFormWrapperEntityInProgress: <TEntity extends IEntity = IEntity>(entity: IFormExtendedEditableEntity<TEntity>) => boolean;
/**
 * @stable [25.09.2019]
 * @param {IGenericFormEntity} formEntity
 * @param {IGenericFieldEntity} fieldProps
 * @returns {boolean}
 */
export declare const isFormFieldReadOnly: (formEntity: IGenericFormEntity, fieldProps: IGenericFieldEntity) => boolean;
