"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var inversify_1 = require("inversify");
var UIDefaultIconFactory = /** @class */ (function () {
    function UIDefaultIconFactory() {
    }
    UIDefaultIconFactory_1 = UIDefaultIconFactory;
    // tslint:enable:max-line-length
    /**
     * @stable [25.01.2019]
     * @param {string} iconName
     * @returns {JSX.Element}
     */
    UIDefaultIconFactory.prototype.makeInstance = function (iconName) {
        return UIDefaultIconFactory_1.SUPPORTED_ICONS_MAPS[iconName];
    };
    var UIDefaultIconFactory_1;
    // tslint:disable:max-line-length
    // https://svg2jsx.herokuapp.com/
    UIDefaultIconFactory.SUPPORTED_ICONS_MAPS = {
        'check-sign': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '10', height: '10', viewBox: '0 0 10 10' },
            React.createElement("defs", null,
                React.createElement("path", { id: '580296fa-0ac3-471c-8d48-c71541b55b55', d: 'M3.125 7.75a.93.93 0 00.663-.277l6.03-6.146a.636.636 0 000-.892.62.62 0 00-.884 0L3.125 6.358 1.067 4.184a.619.619 0 00-.884 0 .636.636 0 000 .893l2.279 2.395a.927.927 0 00.662.277h.001z' })),
            React.createElement("use", { fill: 'currentColor', fillRule: 'evenodd', transform: 'translate(0 1)', xlinkHref: '#580296fa-0ac3-471c-8d48-c71541b55b55' }))),
        'download': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M3 21.006C3 21.003 21 21 21 21c-.006 0 0-7.506 0-7.506a1.5 1.5 0 0 1 3 0v7.512A3.008 3.008 0 0 1 21 24H3c-1.659 0-3-1.338-3-2.994v-7.512a1.5 1.5 0 0 1 3 0v7.512zM7.059 6.408a1.485 1.485 0 0 0-2.121 0 1.536 1.536 0 0 0 0 2.15l5.472 5.782c.423.429.986.666 1.59.666.6 0 1.167-.237 1.59-.668l5.47-5.782a1.534 1.534 0 0 0 0-2.148 1.485 1.485 0 0 0-2.12 0l-3.44 3.72V1.5a1.5 1.5 0 1 0-3 0v8.631l-3.44-3.72-.001-.003z' }))),
        'back2': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M8.59 16.94a1.485 1.485 0 0 1 0 2.121 1.534 1.534 0 0 1-2.147 0L.667 13.59A2.203 2.203 0 0 1 0 12c0-.6.237-1.167.666-1.59l5.775-5.47a1.538 1.538 0 0 1 2.151 0 1.488 1.488 0 0 1 0 2.12l-3.72 3.44H22.5c.83 0 1.5.67 1.5 1.5 0 .825-.672 1.5-1.5 1.5H4.869l3.722 3.441z' }))),
        'back': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M10.59 18.94a1.485 1.485 0 0 1 0 2.121 1.534 1.534 0 0 1-2.147 0L.668 13.59A2.203 2.203 0 0 1 0 12c0-.6.237-1.167.666-1.59l7.775-7.47a1.538 1.538 0 0 1 2.151 0 1.488 1.488 0 0 1 0 2.12l-5.72 5.44H22.5c.83 0 1.5.67 1.5 1.5 0 .825-.672 1.5-1.5 1.5H4.869l5.722 5.441z' }))),
        'filter': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M7.5 12.962L.302 3.402C-.443 2.414.262 1 1.5 1h21c1.237 0 1.943 1.414 1.198 2.402l-7.198 9.56V21.5a1.5 1.5 0 0 1-1.974 1.423l-6-2A1.5 1.5 0 0 1 7.5 19.5v-6.538zM4.507 4l5.691 7.558a1.5 1.5 0 0 1 .302.902v5.959l3 1V12.46a1.5 1.5 0 0 1 .302-.902L19.492 4H4.508z' }))),
        'reports': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("defs", null,
                React.createElement("path", { id: 'd5742bef-cfe6-4617-a227-429cd6a614c2', d: 'M9.5 21h13a1.5 1.5 0 0 0 0-3h-13a1.5 1.5 0 0 0 0 3zm4-7.5h9a1.5 1.5 0 0 0 0-3h-9a1.5 1.5 0 0 0 0 3zM1.5 6h21a1.5 1.5 0 0 0 0-3h-21a1.5 1.5 0 0 0 0 3z' })),
            React.createElement("use", { fill: 'currentColor', transform: 'rotate(90 12 12)', xlinkHref: '#d5742bef-cfe6-4617-a227-429cd6a614c2' }))),
        'cloud': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M23.999 15.958a6.424 6.424 0 0 1-6.315 6.539H7.186a7.46 7.46 0 0 1-7.124-6.5 7.461 7.461 0 0 1 5.234-8.099A8.443 8.443 0 0 1 12.872 3a8.597 8.597 0 0 1 8.383 7.649A6.544 6.544 0 0 1 24 15.958h-.001zm-4.845-3.15l-.75-.404-.045-.85a5.644 5.644 0 0 0-5.489-5.55 5.496 5.496 0 0 0-5.099 3.694l-.315.825-.87.135a4.472 4.472 0 0 0 .6 8.848h10.498A3.433 3.433 0 0 0 21 15.967a3.542 3.542 0 0 0-1.845-3.162v.003z' }))),
        'power': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M12 23.996A11.997 11.997 0 0 1 5.072 2.202a1.499 1.499 0 0 1 2.363 1.082 1.5 1.5 0 0 1-.624 1.365 9.002 9.002 0 0 0-3.39 10.074 9.001 9.001 0 0 0 17.158 0 9 9 0 0 0-3.39-10.074 1.502 1.502 0 1 1 1.74-2.447 12.001 12.001 0 0 1 4.507 13.431A12.002 12.002 0 0 1 12 23.996zm0-11.998a1.5 1.5 0 0 1-1.5-1.5V1.5a1.5 1.5 0 0 1 3 0v8.998a1.5 1.5 0 0 1-1.5 1.5z' }))),
        'passport': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M19.5 24h-15a3 3 0 0 1-3-3V9a3 3 0 0 1 3-3H6c0-3.315 2.685-6 6-6s6 2.685 6 6h1.5a3 3 0 0 1 3 3v12a3 3 0 0 1-3 3zM12 3a3 3 0 0 0-3 3h6a3 3 0 0 0-3-3zm7.5 6h-15v12h15V9zM12 12a3 3 0 1 1 0 6 3 3 0 1 1 0-6z' }))),
        'log-out': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M2.993 21C2.994 21 3 3 3 3c0 .006 7.5 0 7.5 0a1.5 1.5 0 0 0 0-3H2.992A3.007 3.007 0 0 0 0 3v18c0 1.659 1.335 3 2.993 3H10.5a1.5 1.5 0 0 0 0-3H2.992zm16.128-7.5l-3.72 3.441a1.488 1.488 0 0 0 0 2.121 1.534 1.534 0 0 0 2.148 0l5.771-5.47c.43-.425.68-.988.68-1.59 0-.6-.25-1.168-.68-1.59L17.546 4.94a1.53 1.53 0 0 0-2.146 0 1.485 1.485 0 0 0 0 2.121l3.716 3.438H10.5a1.5 1.5 0 1 0 0 3h8.62z' }))),
        'close': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M3.105 5.226a1.501 1.501 0 0 1 0-2.12 1.501 1.501 0 0 1 2.121 0L12 9.877l6.773-6.773a1.501 1.501 0 0 1 2.121 0 1.501 1.501 0 0 1 0 2.121L14.12 12l6.773 6.773a1.501 1.501 0 0 1 0 2.121 1.501 1.501 0 0 1-2.12 0l-6.774-6.773-6.773 6.773a1.501 1.501 0 0 1-2.12 0 1.501 1.501 0 0 1 0-2.12l6.772-6.774-6.773-6.773z' }))),
        'list': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("defs", null,
                React.createElement("path", { id: '334947fd-5c1b-43e4-8b56-f4c74df86320', d: 'M24 20a1.5 1.5 0 0 0-1.5-1.5h-16a1.5 1.5 0 0 0 0 3h16A1.5 1.5 0 0 0 24 20zm0-7.5a1.5 1.5 0 0 0-1.5-1.5h-16a1.5 1.5 0 0 0 0 3h16a1.5 1.5 0 0 0 1.5-1.5zM24 5a1.5 1.5 0 0 0-1.5-1.5h-16a1.5 1.5 0 0 0 0 3h16A1.5 1.5 0 0 0 24 5zM1.5 21.5a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3zm0-7.5a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3zm0-7.5a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3z' })),
            React.createElement("use", { fill: 'currentColor', xlinkHref: '#334947fd-5c1b-43e4-8b56-f4c74df86320' }))),
        'circle': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("defs", null,
                React.createElement("path", { id: '59c5b385-2d73-41c8-8f66-bd296326c848', d: 'M12 24c6.627 0 12-5.373 12-12S18.627 0 12 0 0 5.373 0 12s5.373 12 12 12zm0-3a9 9 0 0 0 9-9 9 9 0 0 0-9-9 9 9 0 0 0-9 9 9 9 0 0 0 9 9z' })),
            React.createElement("use", { fill: 'currentColor', fillRule: 'evenodd', xlinkHref: '#59c5b385-2d73-41c8-8f66-bd296326c848' }))),
        'dropdown': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M12 20.002c.6 0 1.167-.237 1.59-.665l9.972-10.25a1.527 1.527 0 0 0 0-2.141 1.488 1.488 0 0 0-2.121 0L12 16.66 2.56 6.945a1.485 1.485 0 0 0-2.12 0 1.527 1.527 0 0 0 0 2.143l9.968 10.249c.425.428.988.665 1.59.665H12z' }))),
        'home': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M18.005 21c0-.013-11.997 0-11.997 0 .01 0 0-7.502 0-7.502a1.5 1.5 0 0 0-3 0v7.501a3 3 0 0 0 3 3.001h11.997a3 3 0 0 0 2.99-3v-7.502a1.5 1.5 0 1 0-3 0l.009 7.501h.001zm4.652-9.006a1.457 1.457 0 0 1-1.096-.343l-.01.007-9.562-8.134-9.553 8.086c-.303.26-.699.383-1.095.34a1.446 1.446 0 0 1-1.002-.559c-.524-.669-.43-1.63.21-2.187L10.907.394a1.636 1.636 0 0 1 2.13 0l10.415 8.853c.64.558.732 1.519.21 2.186-.243.317-.606.52-1.005.561zm-9.157 4.49v4.508h-3V16.5c0-.83.68-1.496 1.5-1.5.82-.004 1.5.67 1.5 1.483z' }))),
        'favorite': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M21.69 14.242a33.258 33.258 0 0 1-3 3.675 58.134 58.134 0 0 1-3.267 3.23c-.67.611-1.2 1.066-1.515 1.328a3.005 3.005 0 0 1-3.828 0c-.315-.262-.844-.72-1.515-1.329a54.864 54.864 0 0 1-3.273-3.23 33.824 33.824 0 0 1-2.99-3.665A10.843 10.843 0 0 1 .006 8.23a7.273 7.273 0 0 1 2.16-5.452A7.39 7.39 0 0 1 12 2.329a7.384 7.384 0 0 1 9.837.45 7.273 7.273 0 0 1 2.154 5.43 10.809 10.809 0 0 1-2.302 6.034l.001-.001zm-1.975-9.327a4.398 4.398 0 0 0-6.17 0l-1.55 1.533-1.549-1.533a4.415 4.415 0 0 0-6.177 0 4.287 4.287 0 0 0-1.275 3.267c-.06 4.474 9 11.98 9 11.98s9.056-7.5 9-11.985a4.27 4.27 0 0 0-1.28-3.262z' }))),
        'clock': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M12 24C5.373 24 0 18.627 0 12S5.373 0 12 0s12 5.373 12 12-5.373 12-12 12zm0-21a9 9 0 0 0-9 9 9 9 0 0 0 9 9 9 9 0 0 0 9-9 9 9 0 0 0-9-9zm6 10.5h-6a1.498 1.498 0 0 1-1.5-1.485v-6.03c0-.825.672-1.5 1.5-1.5s1.5.675 1.5 1.5V10.5H18a1.5 1.5 0 0 1 0 3z' }))),
        'sale': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M5.5 7a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3zm0 3a4.5 4.5 0 1 1 0-9 4.5 4.5 0 0 1 0 9zm13 10a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3zm0 3a4.5 4.5 0 1 1 0-9 4.5 4.5 0 0 1 0 9zm.272-19.895a1.501 1.501 0 0 1 2.121 0 1.501 1.501 0 0 1 0 2.121L5.226 20.893a1.501 1.501 0 0 1-2.12 0 1.501 1.501 0 0 1 0-2.12L18.771 3.104z' }))),
        'dollar': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M13.5 3.5H17a1.5 1.5 0 0 1 0 3h-3.5v4h1a5 5 0 1 1 0 10h-1v2a1.5 1.5 0 0 1-3 0v-2H6a1.5 1.5 0 0 1 0-3h4.5v-4h-1a5 5 0 1 1 0-10h1v-2a1.5 1.5 0 0 1 3 0v2zm0 10v4h1a2 2 0 1 0 0-4h-1zm-3-3v-4h-1a2 2 0 1 0 0 4h1z' }))),
        'search': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M21.442 23.555a1.481 1.481 0 0 0 2.119 0 1.53 1.53 0 0 0 0-2.145l-4.62-4.62a10.474 10.474 0 0 0 2.079-6.28C21.02 4.707 16.314 0 10.51 0 4.707 0 0 4.705 0 10.51c0 5.806 4.705 10.511 10.51 10.511 2.363 0 4.546-.78 6.3-2.096l4.633 4.63zM3.003 10.51a7.507 7.507 0 1 1 15.014 0 7.506 7.506 0 1 1-15.012 0h-.002z' }))),
        'close-list': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '16', height: '16', viewBox: '0 0 16 16' },
            React.createElement("path", { fill: 'currentColor', d: 'M14 16H2a2 2 0 0 1-2-2V2a2 2 0 0 1 2-2h12a2 2 0 0 1 2 2v12a2 2 0 0 1-2 2zM2 2v12h12V2H2zm9 7H5a1 1 0 0 1 0-2h6a1 1 0 0 1 0 2z' }))),
        'open-list': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '16', height: '16', viewBox: '0 0 16 16' },
            React.createElement("path", { fill: 'currentColor', d: 'M14 16H2a2 2 0 0 1-2-2V2a2 2 0 0 1 2-2h12a2 2 0 0 1 2 2v12a2 2 0 0 1-2 2zM2 2v12h12V2H2zm9 7H9v2a1 1 0 0 1-2 0V9H5a1 1 0 0 1 0-2h2V5a1 1 0 0 1 2 0v2h2a1 1 0 0 1 0 2z' }))),
        'menu': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M1.5 21h21a1.5 1.5 0 0 0 0-3h-21a1.5 1.5 0 0 0 0 3zm0-7.5h21a1.5 1.5 0 0 0 0-3h-21a1.5 1.5 0 0 0 0 3zm0-7.5h21a1.5 1.5 0 0 0 0-3h-21a1.5 1.5 0 0 0 0 3z' }))),
        'dropdown-opened': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("defs", null,
                React.createElement("path", { id: 'dropdown-opened', d: 'M12 17.5c.6 0 1.166-.237 1.59-.665L23.56 6.586a1.527 1.527 0 0 0 0-2.142 1.488 1.488 0 0 0-2.12 0l-9.442 9.714-9.44-9.714a1.485 1.485 0 0 0-2.12 0 1.527 1.527 0 0 0 0 2.142l9.969 10.25c.424.427.987.664 1.59.664h.001z' })),
            React.createElement("use", { fill: 'currentColor', fillRule: 'evenodd', transform: 'matrix(1 0 0 -1 0 21.498)', xlinkHref: '#dropdown-opened' }))),
        'notifications': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M23.925 19.972a1.504 1.504 0 0 1-1.434 1.027h-7.497A2.997 2.997 0 1 1 9 21H1.5c-.645 0-1.22-.412-1.425-1.026A1.504 1.504 0 0 1 .6 18.3a5.984 5.984 0 0 0 2.408-4.8V9C3.008 4.03 7.037 0 12.004 0 16.972 0 21 4.029 21 9v4.5a5.968 5.968 0 0 0 2.4 4.8c.516.386.726 1.06.525 1.672zm-5.676-6.465v-4.5a6.25 6.25 0 0 0-6.246-6.015 6.249 6.249 0 0 0-6.246 6.015v4.5a8.73 8.73 0 0 1-1.25 4.5H19.5a8.741 8.741 0 0 1-1.251-4.5z' }))),
        'plus': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '16', height: '16', viewBox: '0 0 16 16' },
            React.createElement("path", { fill: 'currentColor', d: 'M7 9H1a1 1 0 0 1 0-2h6V1a1 1 0 0 1 2 0v6h6a1 1 0 0 1 0 2H9v6a1 1 0 0 1-2 0V9z' }))),
        'pin-delete-thin': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', width: '40', height: '24', viewBox: '0 0 40 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M10.037 0L0 12l10.037 12h26.766c1.76 0 3.2-1.44 3.2-3.2V3.2c0-1.76-1.44-3.2-3.2-3.2H10.038zm.732 1.6h26.034c.894 0 1.6.706 1.6 1.6v17.6c0 .894-.706 1.6-1.6 1.6H10.772L2 12l8.769-10.4zm7.4 5.034l-1.131 1.132L21.272 12l-4.234 4.234 1.13 1.132 4.235-4.235 4.235 4.235 1.13-1.132L23.535 12l4.235-4.234-1.131-1.132-4.235 4.235-4.234-4.235z' }))),
        'user': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M19.5 7.5C19.5 3.36 16.14 0 12 0 7.86 0 4.5 3.36 4.5 7.5a7.483 7.483 0 0 0 2.625 5.7A10.49 10.49 0 0 0 1.5 22.5a1.5 1.5 0 0 0 3 0c0-4.14 3.36-7.5 7.5-7.5 4.14 0 7.5 3.36 7.5 7.5a1.5 1.5 0 0 0 3 0c0-4.04-2.28-7.545-5.625-9.3A7.483 7.483 0 0 0 19.5 7.5zM12 12a4.5 4.5 0 1 1 0-9 4.5 4.5 0 0 1 0 9z' }))),
        'dashboard': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M21 24h-4.5a3 3 0 0 1-3-3v-4.5a3 3 0 0 1 3-3H21a3 3 0 0 1 3 3V21a3 3 0 0 1-3 3zm0-7.5h-4.5V21H21v-4.5zm0-6h-4.5a3 3 0 0 1-3-3V3a3 3 0 0 1 3-3H21a3 3 0 0 1 3 3v4.5a3 3 0 0 1-3 3zM21 3h-4.5v4.5H21V3zM7.5 24H3a3 3 0 0 1-3-3v-4.5a3 3 0 0 1 3-3h4.5a3 3 0 0 1 3 3V21a3 3 0 0 1-3 3zm0-7.5H3V21h4.5v-4.5zm0-6H3a3 3 0 0 1-3-3V3a3 3 0 0 1 3-3h4.5a3 3 0 0 1 3 3v4.5a3 3 0 0 1-3 3zm0-7.5H3v4.5h4.5V3z' }))),
        'info': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M13.5 21h1.505c.824 0 1.495.666 1.495 1.5 0 .828-.68 1.5-1.495 1.5h-6.01A1.495 1.495 0 0 1 7.5 22.5c0-.828.68-1.5 1.495-1.5H10.5V9H9.015a1.5 1.5 0 1 1 0-3h2.97c.84 0 1.515.666 1.515 1.5V21zM11.25 4.5a2.25 2.25 0 1 0-.002-4.502A2.25 2.25 0 0 0 11.25 4.5z' }))),
        'bottom': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("defs", null,
                React.createElement("path", { id: 'd2470b0a-5052-4460-b072-5074e7b059d2', d: 'M10.59 18.94a1.485 1.485 0 0 1 0 2.121 1.534 1.534 0 0 1-2.147 0L.668 13.59A2.203 2.203 0 0 1 0 12c0-.6.237-1.167.666-1.59l7.775-7.47a1.538 1.538 0 0 1 2.151 0 1.488 1.488 0 0 1 0 2.12l-5.72 5.44H22.5c.83 0 1.5.67 1.5 1.5 0 .825-.672 1.5-1.5 1.5H4.869l5.722 5.441z' })),
            React.createElement("use", { fill: 'currentColor', transform: 'matrix(0 -1 -1 0 24 24)', xlinkHref: '#d2470b0a-5052-4460-b072-5074e7b059d2' }))),
        'minus-circle': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '16', height: '16', viewBox: '0 0 16 16' },
            React.createElement("path", { fill: 'currentColor', d: 'M8 16A8 8 0 1 1 8 0a8 8 0 0 1 0 16zM8 2a6 6 0 1 0 0 12A6 6 0 0 0 8 2zm3.2 7H4.8C4.358 9 4 8.552 4 8s.358-1 .8-1h6.4c.442 0 .8.448.8 1s-.358 1-.8 1z' }))),
        'minus': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M1.5 13.5a1.5 1.5 0 0 1 0-3h21a1.5 1.5 0 0 1 0 3h-21z' }))),
        'top': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("defs", null,
                React.createElement("path", { id: 'a3b37c9b-5637-4c82-9eb5-8aafb265f55a', d: 'M10.59 18.94a1.485 1.485 0 0 1 0 2.121 1.534 1.534 0 0 1-2.147 0L.668 13.59A2.203 2.203 0 0 1 0 12c0-.6.237-1.167.666-1.59l7.775-7.47a1.538 1.538 0 0 1 2.151 0 1.488 1.488 0 0 1 0 2.12l-5.72 5.44H22.5c.83 0 1.5.67 1.5 1.5 0 .825-.672 1.5-1.5 1.5H4.869l5.722 5.441z' })),
            React.createElement("use", { fill: 'currentColor', transform: 'rotate(90 12 12)', xlinkHref: '#a3b37c9b-5637-4c82-9eb5-8aafb265f55a' }))),
        'calendar': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M20.99 24H3.01A3.013 3.013 0 0 1 0 21V6a3.002 3.002 0 0 1 3.012-3H6V1.5a1.5 1.5 0 0 1 3 0V3h6V1.5a1.5 1.5 0 0 1 3 0V3h2.99A3.013 3.013 0 0 1 24 6v15a3.002 3.002 0 0 1-3.012 3h.002zM21 6h-3v1.5a1.5 1.5 0 0 1-3 0V6H9v1.5a1.5 1.5 0 0 1-3 0V6H3v15h18V6zm-4.5 12a1.5 1.5 0 1 1 .001-3.001A1.5 1.5 0 0 1 16.5 18zm0-4.5a1.5 1.5 0 1 1 .001-3.001A1.5 1.5 0 0 1 16.5 13.5zM12 18a1.5 1.5 0 1 1 .001-3.001A1.5 1.5 0 0 1 12 18zm0-4.5a1.5 1.5 0 1 1 .001-3.001A1.5 1.5 0 0 1 12 13.5zM7.5 18a1.5 1.5 0 1 1 .001-3.001A1.5 1.5 0 0 1 7.5 18zm0-4.5a1.5 1.5 0 1 1 .001-3.001A1.5 1.5 0 0 1 7.5 13.5z' }))),
        'ok-filled': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("defs", null,
                React.createElement("path", { id: 'bb85799a-fb90-4b35-86f9-4f4d227ab135', d: 'M12 24c6.627 0 12-5.373 12-12S18.627 0 12 0 0 5.373 0 12s5.373 12 12 12zm-1.5-7.5c.6 0 1.167-.237 1.59-.665l5.472-5.749a1.527 1.527 0 0 0 0-2.142 1.488 1.488 0 0 0-2.121 0L10.5 13.158l-1.94-2.214a1.488 1.488 0 0 0-2.12 0 1.527 1.527 0 0 0 0 2.142l2.468 2.75c.425.427.988.664 1.59.664h.002z' })),
            React.createElement("use", { fill: 'currentColor', fillRule: 'evenodd', xlinkHref: '#bb85799a-fb90-4b35-86f9-4f4d227ab135' }))),
        'money': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '80', height: '80', viewBox: '0 0 80 80' },
            React.createElement("path", { id: 'a', d: 'M40 4c-2.16 0-3.969 1.406-4.66 3.336C34.45 6.527 33.293 6 32 6c-2.75 0-5 2.25-5 5v1.863c-.727-.5-1.555-.863-2.5-.863a4.516 4.516 0 0 0-4.5 4.5V19H5v40h15.094l.265 2.672c.25 2.484 1.696 4.516 3.641 5.828V76h2v-8c.55 0 1-.45 1-1a1.002 1.002 0 0 0-1.578-.816 6.122 6.122 0 0 1-3.07-4.715L22.105 59h24.223l8.504-7.402.09-.215S57.039 46 63.742 46c2.766 0 3.684 1.371 4.012 1.965-.73.926-5.965 7.562-6.574 8.32l-8.7 10.86c-.43.53-2.48 2.628-2.48 5.828V76h2v-3.027c0-2.383 1.375-3.754 2.035-4.575h.004L61.57 59H75V19H53v-8c0-2.75-2.25-5-5-5-1.293 0-2.45.527-3.34 1.336C43.97 5.406 42.16 4 40 4zm0 2c1.668 0 3 1.332 3 3v2h2c0-1.668 1.332-3 3-3s3 1.332 3 3v8h-6c0-.55-.45-1-1-1s-1 .45-1 1h-6c0-.55-.45-1-1-1s-1 .45-1 1H22v-2.5c0-1.39 1.11-2.5 2.5-2.5s2.5 1.11 2.5 2.5h2V11c0-1.668 1.332-3 3-3s3 1.332 3 3c0 .55.45 1 1 1s1-.45 1-1V9c0-1.668 1.332-3 3-3zm-4 8c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm8 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zM7 21h66v36h-9.836c1.277-1.605 6.621-8.379 6.621-8.379l.375-.48-.25-.551S68.16 44 63.742 44c-7.304 0-10.172 5.61-10.523 6.352L45.579 57H7V21zm9 2c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-49 3c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm50 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-52 2c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm27 0c-6.063 0-11 4.938-11 11 0 6.063 4.938 11 11 11 6.063 0 11-4.938 11-11 0-6.063-4.938-11-11-11zm27 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-57 1c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm60 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-30 1c4.98 0 9 4.02 9 9s-4.02 9-9 9-9-4.02-9-9 4.02-9 9-9zm-30 2c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm60 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-60 3c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm9 0c-2.2 0-4 1.8-4 4s1.8 4 4 4 4-1.8 4-4-1.8-4-4-4zm41 0c-2.2 0-4 1.8-4 4s1.8 4 4 4 4-1.8 4-4-1.8-4-4-4zm10 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-51 2c1.117 0 2 .883 2 2s-.883 2-2 2-2-.883-2-2 .883-2 2-2zm41 0c1.117 0 2 .883 2 2s-.883 2-2 2-2-.883-2-2 .883-2 2-2zm-50 1c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm60 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-60 3c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm60 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-60 3c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm0 3c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 1c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm2 2c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm1 3c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm3 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zM30 66c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1z' }))),
        'delivery': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', width: '80', height: '80', viewBox: '0 0 80 80' },
            React.createElement("path", { fill: 'currentColor', d: 'M1 10c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0a1.006 1.006 0 0 0-.879.496 1.01 1.01 0 0 0 0 1.008c.184.312.52.5.879.496h40v35c-.55 0-1 .45-1 1s.45 1 1 1v11H25.941c-.5-4.488-4.32-8-8.941-8s-8.441 3.512-8.941 8H5V49c.55 0 1-.45 1-1s-.45-1-1-1H2v-6H0v8h3v13h5.059c.5 4.488 4.32 8 8.941 8s8.441-3.512 8.941-8H50.06c.5 4.488 4.32 8 8.941 8s8.441-3.512 8.941-8H78c1.094 0 2-.906 2-2v-4c0-.707-.438-1.227-1-1.582V40.547L72.414 24.48A7.006 7.006 0 0 0 65.887 20H47V10H5zm-1 6c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zM1 22c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm14 0h14v13c0 2.2 1.8 4 4 4h1.395a1.99 1.99 0 0 1 1.664.89l.218.329A4.001 4.001 0 0 0 71.605 42H77v2h-2c-2.2 0-4 1.8-4 4v1h.203c.457 1.707 1.953 3 3.797 3h2v2c-.55 0-1 .45-1 1s.45 1 1 1h1v4H67.941c-.5-4.488-4.32-8-8.941-8s-8.441 3.512-8.941 8H47V22zm16 0h2.887a4.99 4.99 0 0 1 4.66 3.2L76.645 40h-5.04a1.99 1.99 0 0 1-1.664-.89l-.222-.329a3.99 3.99 0 0 0-3.324-1.78H65c-1.117 0-2-.884-2-2V22zm-10 2c-1.645 0-3 1.356-3 3v9c0 1.645 1.355 3 3 3h2c1.645 0 3-1.355 3-3v-9c0-1.644-1.355-3-3-3h-2zm0 2h2c.566 0 1 .434 1 1v9c0 .566-.434 1-1 1h-2c-.566 0-1-.434-1-1v-9c0-.566.434-1 1-1zM4 28c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zM1 34c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm58 12h2v4h-2c-1.117 0-2-.883-2-2s.883-2 2-2zM9 47c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-24 7c3.879 0 7 3.121 7 7s-3.121 7-7 7-7-3.121-7-7 3.121-7 7-7zm42 0c3.879 0 7 3.121 7 7s-3.121 7-7 7-7-3.121-7-7 3.121-7 7-7zm10 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-56 4c-1.645 0-3 1.356-3 3 0 1.645 1.355 3 3 3s3-1.355 3-3c0-1.644-1.355-3-3-3zm42 0c-1.645 0-3 1.356-3 3 0 1.645 1.355 3 3 3s3-1.355 3-3c0-1.644-1.355-3-3-3zm-42 2c.563 0 1 .438 1 1 0 .563-.438 1-1 1-.563 0-1-.437-1-1 0-.562.438-1 1-1zm42 0c.563 0 1 .438 1 1 0 .563-.438 1-1 1-.563 0-1-.437-1-1 0-.562.438-1 1-1z' }))),
        'vault': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '80', height: '80', viewBox: '0 0 80 80' },
            React.createElement("path", { fill: 'currentColor', d: 'M11 15c-2.75 0-5 2.25-5 5v38c0 2.75 2.25 5 5 5h1v1c0 .55.45 1 1 1h6c.55 0 1-.45 1-1v-1h40v1c0 .55.45 1 1 1h6c.55 0 1-.45 1-1v-1h1c2.75 0 5-2.25 5-5V20c0-2.75-2.25-5-5-5H11zm0 2h58c1.668 0 3 1.332 3 3v38c0 1.668-1.332 3-3 3H11c-1.668 0-3-1.332-3-3V20c0-1.668 1.332-3 3-3zm1 3c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-56 4c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm56 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-20 2c-7.168 0-13 5.832-13 13s5.832 13 13 13 13-5.832 13-13-5.832-13-13-13zm-27 1c-1.645 0-3 1.355-3 3v18c0 1.645 1.355 3 3 3s3-1.355 3-3V30c0-1.645-1.355-3-3-3zm-9 1c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm56 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-20.996.05a1 1 0 0 0 1.996 0 10.953 10.953 0 0 1 6.043 2.497.998.998 0 0 0 1.41 1.41 10.925 10.925 0 0 1 2.496 6.047 1 1 0 0 0 0 1.996 10.953 10.953 0 0 1-2.496 6.043.965.965 0 0 0-.66-.262 1 1 0 0 0-.75 1.676 10.92 10.92 0 0 1-6.047 2.492 1 1 0 0 0-1.996 0 10.965 10.965 0 0 1-6.047-2.496.998.998 0 0 0-.719-1.676.999.999 0 0 0-.687.266 10.925 10.925 0 0 1-2.496-6.047 1 1 0 0 0 0-1.996 10.953 10.953 0 0 1 2.496-6.043.998.998 0 0 0 1.41-1.41 10.925 10.925 0 0 1 6.047-2.496zM21 29c.566 0 1 .434 1 1v18c0 .566-.434 1-1 1-.566 0-1-.434-1-1V30c0-.566.434-1 1-1zm-9 3c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm36 0c-3.855 0-7 3.145-7 7s3.145 7 7 7 7-3.145 7-7-3.145-7-7-7zm20 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-20 2c2.773 0 5 2.227 5 5s-2.227 5-5 5-5-2.227-5-5 2.227-5 5-5zm-36 2c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm56 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-56 4c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm56 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-56 4c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm56 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-56 4c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm56 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-56 4c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm56 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm-56 4c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1zm4 0c-.55 0-1 .45-1 1s.45 1 1 1 1-.45 1-1-.45-1-1-1z' }))),
        'receipt': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', width: '80', height: '80', viewBox: '0 0 80 80' },
            React.createElement("path", { fill: 'currentColor', d: 'M21 10v29.617h-1a1.999 1.999 0 1 0 0 4h40c1.105 0 2-.894 2-2 0-1.105-.895-2-2-2h-1V10l-2.992 1.496-1.926-.996-2.074 1.004L50 10.5l-2 1-2-1-1.992.996-1.926-.996L40 11.508 37.918 10.5 36 11.492l-1.918-.992L32 11.508 29.918 10.5l-1.934 1-2.066-1-1.926.996L21 10zm4.95 2.734l2.066 1 1.933-1 2.051.993 2.05-.993L36 13.742l1.95-1.008 2.05.993 2.05-.993 1.942 1.004L46 12.734l2 1 2-1 1.992.996 2.059-.996 1.941 1.004L57 13.234v28.383H23V13.234l1.008.504 1.941-1.004zM27 20.617v2h16v-2H27zm20 0v2h6v-2h-6zm-20 6v2h12v-2H27zm20 0v2h6v-2h-6zm-30 4c-3.855 0-7 3.145-7 7v32h2v-32c0-2.773 2.227-5 5-5h2v-2h-2zm44 0v2h2c2.773 0 5 2.227 5 5v32h2v-32c0-3.855-3.145-7-7-7h-2zm-35 4c-.55 0-1 .45-1 1 0 .551.45 1 1 1s1-.449 1-1c0-.55-.45-1-1-1zm4 0c-.55 0-1 .45-1 1 0 .551.45 1 1 1s1-.449 1-1c0-.55-.45-1-1-1zm4 0c-.55 0-1 .45-1 1 0 .551.45 1 1 1s1-.449 1-1c0-.55-.45-1-1-1zm4 0c-.55 0-1 .45-1 1 0 .551.45 1 1 1s1-.449 1-1c0-.55-.45-1-1-1zm4 0c-.55 0-1 .45-1 1 0 .551.45 1 1 1s1-.449 1-1c0-.55-.45-1-1-1zm4 0c-.55 0-1 .45-1 1 0 .551.45 1 1 1s1-.449 1-1c0-.55-.45-1-1-1zm4 0c-.55 0-1 .45-1 1 0 .551.45 1 1 1s1-.449 1-1c0-.55-.45-1-1-1zm4 0c-.55 0-1 .45-1 1 0 .551.45 1 1 1s1-.449 1-1c0-.55-.45-1-1-1zm-33 14c-1.094 0-2 .906-2 2v6c0 1.094.906 2 2 2h39c1.094 0 2-.906 2-2v-6c0-1.094-.906-2-2-2H21zm0 2h39v6H21v-6zm0 11c-1.094 0-2 .906-2 2v4c0 1.094.906 2 2 2h4c1.094 0 2-.906 2-2v-4c0-1.094-.906-2-2-2h-4zm10 0c-1.094 0-2 .906-2 2v4c0 1.094.906 2 2 2h4c1.094 0 2-.906 2-2v-4c0-1.094-.906-2-2-2h-4zm10 0c-1.094 0-2 .906-2 2v4c0 1.094.906 2 2 2h4c1.094 0 2-.906 2-2v-4c0-1.094-.906-2-2-2h-4zm15 0c-1.094 0-2 .906-2 2v4c0 1.094.906 2 2 2h4c1.094 0 2-.906 2-2v-4c0-1.094-.906-2-2-2h-4zm-35 2h4v4h-4v-4zm10 0h4v4h-4v-4zm10 0h4v4h-4v-4zm15 0h4v4h-4v-4z' }))),
        'left-right': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M7.094 15.441a1.49 1.49 0 0 1 0 2.12 1.536 1.536 0 0 1-2.15 0L.668 13.59a2.231 2.231 0 0 1-.002-3.181l4.277-3.97a1.538 1.538 0 0 1 2.151 0 1.49 1.49 0 0 1 0 2.121l-2.22 1.936h14.254l-2.22-1.937a1.487 1.487 0 0 1 .002-2.121 1.53 1.53 0 0 1 2.144 0l4.28 3.97a2.23 2.23 0 0 1 0 3.183l-4.287 3.966a1.528 1.528 0 0 1-2.149 0 1.487 1.487 0 0 1 0-2.12l2.221-1.94H4.859l2.235 1.943z' }))),
        'search-thin': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M17.583 16.52l5.95 5.945c.707.707-.354 1.768-1.061 1.061l-5.95-5.945A9.96 9.96 0 0 1 10 20C4.477 20 0 15.523 0 10S4.477 0 10 0s10 4.477 10 10a9.96 9.96 0 0 1-2.417 6.52zM10 18.5a8.5 8.5 0 1 0 0-17 8.5 8.5 0 0 0 0 17z' }))),
        'password': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M19.5 24h-15a3 3 0 0 1-3-3V9a3 3 0 0 1 3-3H6c0-3.315 2.685-6 6-6s6 2.685 6 6h1.5a3 3 0 0 1 3 3v12a3 3 0 0 1-3 3zM12 3a3 3 0 0 0-3 3h6a3 3 0 0 0-3-3zm7.5 6h-15v12h15V9zM12 12a3 3 0 1 1 0 6 3 3 0 1 1 0-6z' }))),
        'edit': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '16', height: '16', viewBox: '0 0 16 16' },
            React.createElement("path", { fill: 'currentColor', d: 'M15.015 5.356l-8.658 8.656a4.411 4.411 0 0 1-1.732.98l-2.64.66-1.185.3a.572.572 0 1 1-.753-.752l.3-1.183.66-2.64c.19-.646.525-1.24.98-1.734L10.645.987c.77-.83 1.93-1.17 3.027-.89a3.092 3.092 0 0 1 1.342 5.26v-.001zM3.39 11.046c-.2.24-.354.514-.457.81l-.403 1.613 1.613-.405c.294-.103.568-.258.808-.457l6.824-6.822-.035-.035-1.493-1.49-.036-.037-6.82 6.824-.001-.001zM13.61 2.39a1.107 1.107 0 0 0-1.562 0l-.43.432.035.035 1.492 1.492.035.034.43-.43a1.109 1.109 0 0 0 0-1.565v.002z' }))),
        'check': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', width: '64', height: '64', viewBox: '0 0 64 64' },
            React.createElement("path", { fill: 'currentColor', d: 'M7 2v56.617H6a1.999 1.999 0 1 0 0 4h52c1.105 0 2-.894 2-2 0-1.105-.895-2-2-2h-1V2l-2.992 1.496-1.926-.996-2.074 1.004L48 2.5l-2 1-2-1-1.992.996-1.926-.996-2.074 1.004L36 2.5l-2.008 1.004L31.918 2.5l-1.926.996L28 2.5l-2.008 1.004L23.918 2.5 22 3.492 20.082 2.5 18 3.508 15.918 2.5l-1.934 1-2.066-1-1.926.996L7 2zm4.95 2.734l2.066 1 1.933-1L18 5.727l2.05-.993L22 5.742l1.95-1.008 2.058.996L28 4.734l2.008 1.004 1.941-1.004 2.059.996L36 4.734l1.992.996 2.059-.996 1.941 1.004L44 4.734l2 1 2-1 1.992.996 2.059-.996 1.941 1.004L55 5.234v55.383H9V5.234l1.008.504 1.941-1.004zM15 13.617v2h22v-2H15zm28 0v2h6v-2h-6zm-28 6v2h18v-2H15zm28 0v2h6v-2h-6zm-28 6v2h22v-2H15zm28 0v2h6v-2h-6zm-28 6v2h18v-2H15zm28 0v2h6v-2h-6zm-28 6v2h22v-2H15zm28 0v2h6v-2h-6zm-31 8c-.55 0-1 .45-1 1 0 .551.45 1 1 1s1-.449 1-1c0-.55-.45-1-1-1zm4 0c-.55 0-1 .45-1 1 0 .551.45 1 1 1s1-.449 1-1c0-.55-.45-1-1-1zm4 0c-.55 0-1 .45-1 1 0 .551.45 1 1 1s1-.449 1-1c0-.55-.45-1-1-1zm4 0c-.55 0-1 .45-1 1 0 .551.45 1 1 1s1-.449 1-1c0-.55-.45-1-1-1zm4 0c-.55 0-1 .45-1 1 0 .551.45 1 1 1s1-.449 1-1c0-.55-.45-1-1-1zm4 0c-.55 0-1 .45-1 1 0 .551.45 1 1 1s1-.449 1-1c0-.55-.45-1-1-1zm4 0c-.55 0-1 .45-1 1 0 .551.45 1 1 1s1-.449 1-1c0-.55-.45-1-1-1zm4 0c-.55 0-1 .45-1 1 0 .551.45 1 1 1s1-.449 1-1c0-.55-.45-1-1-1zm4 0c-.55 0-1 .45-1 1 0 .551.45 1 1 1s1-.449 1-1c0-.55-.45-1-1-1zm4 0c-.55 0-1 .45-1 1 0 .551.45 1 1 1s1-.449 1-1c0-.55-.45-1-1-1zm4 0c-.55 0-1 .45-1 1 0 .551.45 1 1 1s1-.449 1-1c0-.55-.45-1-1-1zm-17 8v2h14v-2H35z' }))),
        'cart': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '16', height: '16', viewBox: '0 0 16 16' },
            React.createElement("path", { fill: 'currentColor', d: 'M15.954 6.178l-1.62 8.047A2.238 2.238 0 0 1 12.194 16H3.808a2.237 2.237 0 0 1-2.142-1.776L.046 6.178a1.778 1.778 0 0 1 .347-1.52c.344-.426.865-.67 1.41-.658h2.208c0-2.21 1.79-4 3.995-4a3.997 3.997 0 0 1 3.995 4h2.197a1.772 1.772 0 0 1 1.758 2.178h-.002zM3.591 13.823a.28.28 0 0 0 .22.178h8.382a.28.28 0 0 0 .218-.178l.37-1.822H3.226l.366 1.822H3.59zM8.005 2a1.999 1.999 0 0 0-1.998 2H10c0-1.105-.894-2-1.997-2h.001zM2.019 6l.805 4h10.362l.81-4.006H2.011L2.02 6h-.002z' }))),
        'chat': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M11.99 20.992A9.008 9.008 0 0 1 7.543 4.156a9.013 9.013 0 0 1 10.88 1.518 9.001 9.001 0 0 1 1.32 10.905c-.21.357-.262.783-.15 1.18l.753 2.553-2.577-.735a1.5 1.5 0 0 0-1.18.15 8.986 8.986 0 0 1-4.6 1.265zm10.095 2.94a1.501 1.501 0 0 0 1.858-1.854c-.15-.525-1.3-4.54-1.299-4.553A11.998 11.998 0 0 0 3.514 3.514 11.996 11.996 0 0 0 17.53 22.642l4.56 1.293h-.004v-.003z' }))),
        'blur-card': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M23.932 9.268l-2.43 12.07A3.356 3.356 0 0 1 18.292 24H5.711a3.356 3.356 0 0 1-3.214-2.664L.07 9.267c-.186-.799.004-1.64.52-2.28A2.643 2.643 0 0 1 2.705 6h3.311c0-3.315 2.685-6 5.993-6a5.996 5.996 0 0 1 5.993 6h3.296a2.658 2.658 0 0 1 2.637 3.268h-.003zM5.386 20.734a.42.42 0 0 0 .33.267H18.29a.419.419 0 0 0 .327-.267l.555-2.733H4.839l.549 2.733h-.002zM12.007 3A2.998 2.998 0 0 0 9.01 6h5.992c0-1.657-1.341-3-2.996-3h.001zm-8.98 6l1.208 6H19.78l1.215-6.008H3.016L3.03 9h-.003z' }))),
        'item-list': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M24 20a1.5 1.5 0 0 0-1.5-1.5h-16a1.5 1.5 0 0 0 0 3h16A1.5 1.5 0 0 0 24 20zm0-7.5a1.5 1.5 0 0 0-1.5-1.5h-16a1.5 1.5 0 0 0 0 3h16a1.5 1.5 0 0 0 1.5-1.5zM24 5a1.5 1.5 0 0 0-1.5-1.5h-16a1.5 1.5 0 0 0 0 3h16A1.5 1.5 0 0 0 24 5zM1.5 21.5a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3zm0-7.5a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3zm0-7.5a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3z' }))),
        'trash': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("defs", null,
                React.createElement("path", { id: '824ac6b3-dec4-4355-bf5e-08524aeebf4f', d: 'M21.5 9H21v12a3 3 0 0 1-3 3H6a3 3 0 0 1-3-3V9h-.5a1.5 1.5 0 0 1 0-3H6c0-3 2-6 6-6s6 3 6 6h3.5a1.5 1.5 0 0 1 0 3zM18 9v12H6V9h12zm-3-3H9c0-2 1-3 3-3s3 1 3 3zm-5.5 5a1.5 1.5 0 0 1 1.5 1.5v5a1.5 1.5 0 0 1-3 0v-5A1.5 1.5 0 0 1 9.5 11zm5 0a1.5 1.5 0 0 1 1.5 1.5v5a1.5 1.5 0 0 1-3 0v-5a1.5 1.5 0 0 1 1.5-1.5z' })),
            React.createElement("use", { fill: 'currentColor', fillRule: 'evenodd', xlinkHref: '#824ac6b3-dec4-4355-bf5e-08524aeebf4f' }))),
        'forward': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("defs", null,
                React.createElement("path", { id: '4696442e-6afc-43cd-85c9-b7bb0e931cd2', d: 'M10.59 18.94a1.485 1.485 0 0 1 0 2.121 1.534 1.534 0 0 1-2.147 0L.668 13.59A2.203 2.203 0 0 1 0 12c0-.6.237-1.167.666-1.59l7.775-7.47a1.538 1.538 0 0 1 2.151 0 1.488 1.488 0 0 1 0 2.12l-5.72 5.44H22.5c.83 0 1.5.67 1.5 1.5 0 .825-.672 1.5-1.5 1.5H4.869l5.722 5.441z' })),
            React.createElement("use", { fill: 'currentColor', transform: 'matrix(-1 0 0 1 24 0)', xlinkHref: '#4696442e-6afc-43cd-85c9-b7bb0e931cd2' }))),
        'forward2': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("defs", null,
                React.createElement("path", { id: '1105b247-6581-48d6-b56d-dca80b8aff5e', d: 'M8.59 16.94a1.485 1.485 0 0 1 0 2.121 1.534 1.534 0 0 1-2.147 0L.667 13.59A2.203 2.203 0 0 1 0 12c0-.6.237-1.167.666-1.59l5.775-5.47a1.538 1.538 0 0 1 2.151 0 1.488 1.488 0 0 1 0 2.12l-3.72 3.44H22.5c.83 0 1.5.67 1.5 1.5 0 .825-.672 1.5-1.5 1.5H4.869l3.722 3.441z' })),
            React.createElement("use", { fill: 'currentColor', fillRule: 'evenodd', transform: 'matrix(-1 0 0 1 24 0)', xlinkHref: '#1105b247-6581-48d6-b56d-dca80b8aff5e' }))),
        'key-delete': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', width: '48', height: '48', viewBox: '0 0 48 48' },
            React.createElement("path", { fill: 'currentColor', d: 'M4 24l12 16h28V8H16L4 24zM.879 21.879l13-17A3 3 0 0 1 16 4h29a3 3 0 0 1 3 3v34a3 3 0 0 1-3 3H16a3 3 0 0 1-2.121-.879l-13-17a3 3 0 0 1 0-4.242zM25.172 24l-5.657-5.657c-.586-.585-1.063-1.766 0-2.828 1.062-1.063 2.243-.586 2.828 0L28 21.172l5.657-5.657c.585-.586 1.768-1.06 2.828 0 1.06 1.06.586 2.243 0 2.828L30.828 24l5.657 5.657c.586.585 1.058 1.77 0 2.828-1.058 1.058-2.243.586-2.828 0L28 26.828l-5.657 5.657c-.585.586-1.768 1.06-2.828 0-1.06-1.06-.586-2.243 0-2.828L25.172 24z' }))),
        'ok': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("defs", null,
                React.createElement("path", { id: '61000029-3ad6-4fb3-a4a7-c6e231a79d7a', d: 'M12 24c6.627 0 12-5.373 12-12S18.627 0 12 0 0 5.373 0 12s5.373 12 12 12zm0-3a9 9 0 0 0 9-9 9 9 0 0 0-9-9 9 9 0 0 0-9 9 9 9 0 0 0 9 9zm-1.5-4.5c.6 0 1.167-.237 1.59-.665l5.472-5.749a1.527 1.527 0 0 0 0-2.142 1.488 1.488 0 0 0-2.121 0L10.5 13.158l-1.94-2.214a1.488 1.488 0 0 0-2.12 0 1.527 1.527 0 0 0 0 2.142l2.468 2.75c.425.427.988.664 1.59.664h.002z' })),
            React.createElement("use", { fill: 'currentColor', fillRule: 'evenodd', xlinkHref: '#61000029-3ad6-4fb3-a4a7-c6e231a79d7a' }))),
        'icons-search': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M21.442 23.555a1.481 1.481 0 0 0 2.119 0 1.53 1.53 0 0 0 0-2.145l-4.62-4.62a10.474 10.474 0 0 0 2.079-6.28C21.02 4.707 16.314 0 10.51 0 4.707 0 0 4.705 0 10.51c0 5.806 4.705 10.511 10.51 10.511 2.363 0 4.546-.78 6.3-2.096l4.633 4.63zM3.003 10.51a7.507 7.507 0 1 1 15.014 0 7.506 7.506 0 1 1-15.012 0h-.002z' }))),
        'settings': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M22.5 14H21a1.5 1.5 0 0 1 0-3h1.5a1.5 1.5 0 0 1 0 3zm0-7.5H11.58A2.972 2.972 0 0 1 9 8a3 3 0 1 1 0-6c1.065 0 2.052.573 2.58 1.5H22.5a1.5 1.5 0 0 1 0 3zM3 6.5H1.5a1.5 1.5 0 0 1 0-3H3a1.5 1.5 0 0 1 0 3zM1.5 11h10.92A2.972 2.972 0 0 1 15 9.5a3 3 0 1 1 0 6 2.972 2.972 0 0 1-2.58-1.5H1.5a1.5 1.5 0 0 1 0-3zm0 7.5H3a1.5 1.5 0 0 1 0 3H1.5a1.5 1.5 0 0 1 0-3zm10.08 0H22.5a1.5 1.5 0 0 1 0 3H11.58A2.972 2.972 0 0 1 9 23a3 3 0 1 1 0-6c1.065 0 2.052.573 2.58 1.5z' }))),
        'id': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '80', height: '80', viewBox: '0 0 80 80' },
            React.createElement("path", { fill: 'currentColor', d: 'M40 3c-3.302 0-6 2.698-6 6v2H18c-1.645 0-3 1.355-3 3v56c0 1.645 1.355 3 3 3h30.537a18.819 18.819 0 0 1-1.264-2H18c-.565 0-1-.435-1-1V14c0-.565.435-1 1-1h16v2h-1c-2.197 0-4 1.803-4 4v1h.203c.456 1.706 1.953 3 3.797 3h14c1.844 0 3.34-1.294 3.797-3H51v-1c0-2.197-1.803-4-4-4h-1v-2h16c.565 0 1 .435 1 1v29h2V14c0-1.645-1.355-3-3-3H46V9c0-3.302-2.698-6-6-6zm0 2c2.22 0 4 1.78 4 4v7c0 .565-.435 1-1 1h-6c-.565 0-1-.435-1-1V9c0-2.22 1.78-4 4-4zm0 3a1 1 0 1 0 0 2 1 1 0 0 0 0-2zm-18 9a1 1 0 1 0 0 2 1 1 0 0 0 0-2zm11 0h1.188c.417 1.157 1.519 2 2.812 2h6c1.293 0 2.395-.843 2.813-2H47c1.117 0 2 .883 2 2s-.883 2-2 2H33c-1.117 0-2-.883-2-2s.883-2 2-2zm-11 4a1 1 0 1 0 0 2 1 1 0 0 0 0-2zm0 4a1 1 0 1 0 0 2 1 1 0 0 0 0-2zm0 4a1 1 0 1 0 0 2 1 1 0 0 0 0-2zm0 4a1 1 0 1 0 0 2 1 1 0 0 0 0-2zm18 0c-3.854 0-7 3.146-7 7a7.004 7.004 0 0 0 3.088 5.799C32.513 47.325 30 50.874 30 55h2c0-4.411 3.589-8 8-8 3.529 0 6.525 2.3 7.586 5.477.402-.69.847-1.35 1.33-1.983a10.066 10.066 0 0 0-5.018-4.687A7.003 7.003 0 0 0 47 40c0-3.854-3.146-7-7-7zm0 2c2.773 0 5 2.227 5 5s-2.227 5-5 5-5-2.227-5-5 2.227-5 5-5zm-18 2a1 1 0 1 0 0 2 1 1 0 0 0 0-2zm0 4a1 1 0 1 0 0 2 1 1 0 0 0 0-2zm0 4a1 1 0 1 0 0 2 1 1 0 0 0 0-2zm42 1c-6.043 0-11.314 3.37-14.035 8.328v-.012c-.122.222-.225.456-.336.684h.006A15.874 15.874 0 0 0 48 62c0 8.822 7.178 16 16 16s16-7.178 16-16-7.178-16-16-16zm0 2c7.72 0 14 6.28 14 14s-6.28 14-14 14-14-6.28-14-14 6.28-14 14-14zm-42 1a1 1 0 1 0 0 2 1 1 0 0 0 0-2zm0 4a1 1 0 1 0 0 2 1 1 0 0 0 0-2zm48.78 3.227l-9.495 9.289-3.646-3.717-1.428 1.398 5.045 5.145 10.922-10.686-1.399-1.43zM22 57a1 1 0 1 0 0 2 1 1 0 0 0 0-2zm0 4a1 1 0 1 0 0 2 1 1 0 0 0 0-2zm0 4a1 1 0 1 0 0 2 1 1 0 0 0 0-2z' }))),
        'card': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', width: '64', height: '64', viewBox: '0 0 64 64' },
            React.createElement("path", { fill: 'currentColor', d: 'M4.571 7A4.585 4.585 0 0 0 0 11.571V40.83A4.585 4.585 0 0 0 4.571 45.4h4.572v6.4a4.585 4.585 0 0 0 4.571 4.571H59.43A4.585 4.585 0 0 0 64 51.8V24.371a4.585 4.585 0 0 0-4.571-4.571h-2.743v-8.229A4.585 4.585 0 0 0 52.114 7H4.571zm0 1.829h47.543a2.73 2.73 0 0 1 2.743 2.742v2.743H1.83v-2.743A2.73 2.73 0 0 1 4.57 8.83zM1.83 17.97h53.028V40.83a2.73 2.73 0 0 1-2.743 2.742H4.571A2.73 2.73 0 0 1 1.83 40.83V17.97zm54.857 3.658h2.743a2.73 2.73 0 0 1 2.742 2.742v2.743h-5.485V21.63zm-51.2 2.742a.916.916 0 0 0-.915.915c0 .503.411.914.915.914.503 0 .914-.41.914-.914a.916.916 0 0 0-.914-.915zm3.657 0a.916.916 0 0 0-.914.915c0 .503.41.914.914.914.503 0 .914-.41.914-.914a.916.916 0 0 0-.914-.915zm3.657 0a.916.916 0 0 0-.914.915c0 .503.41.914.914.914s.914-.41.914-.914a.916.916 0 0 0-.914-.915zm3.657 0a.916.916 0 0 0-.914.915c0 .503.41.914.914.914s.914-.41.914-.914a.916.916 0 0 0-.914-.915zm3.657 0a.916.916 0 0 0-.914.915c0 .503.41.914.914.914s.915-.41.915-.914a.916.916 0 0 0-.915-.915zm3.657 0a.916.916 0 0 0-.914.915c0 .503.41.914.914.914s.915-.41.915-.914a.916.916 0 0 0-.915-.915zm3.658 0a.916.916 0 0 0-.915.915c0 .503.411.914.915.914.503 0 .914-.41.914-.914a.916.916 0 0 0-.914-.915zm29.257 6.4h5.485V51.8a2.73 2.73 0 0 1-2.742 2.743H13.714a2.73 2.73 0 0 1-2.743-2.743v-6.4h41.143a4.585 4.585 0 0 0 4.572-4.571V30.77zM5.486 39a.916.916 0 0 0-.915.914c0 .504.411.915.915.915.503 0 .914-.411.914-.915A.916.916 0 0 0 5.486 39zm3.657 0a.916.916 0 0 0-.914.914c0 .504.41.915.914.915.503 0 .914-.411.914-.915A.916.916 0 0 0 9.143 39zm3.657 0a.916.916 0 0 0-.914.914c0 .504.41.915.914.915s.914-.411.914-.915A.916.916 0 0 0 12.8 39zm3.657 0a.916.916 0 0 0-.914.914c0 .504.41.915.914.915s.914-.411.914-.915a.916.916 0 0 0-.914-.914zm3.657 0a.916.916 0 0 0-.914.914c0 .504.41.915.914.915s.915-.411.915-.915a.916.916 0 0 0-.915-.914zm3.657 0a.916.916 0 0 0-.914.914c0 .504.41.915.914.915s.915-.411.915-.915A.916.916 0 0 0 23.77 39zm3.658 0a.916.916 0 0 0-.915.914c0 .504.411.915.915.915.503 0 .914-.411.914-.915a.916.916 0 0 0-.914-.914zm3.657 0a.916.916 0 0 0-.915.914c0 .504.411.915.915.915.503 0 .914-.411.914-.915a.916.916 0 0 0-.914-.914zm3.657 0a.916.916 0 0 0-.914.914c0 .504.41.915.914.915.503 0 .914-.411.914-.915a.916.916 0 0 0-.914-.914zm3.657 0a.916.916 0 0 0-.914.914c0 .504.41.915.914.915s.914-.411.914-.915A.916.916 0 0 0 38.4 39zm3.657 0a.916.916 0 0 0-.914.914c0 .504.41.915.914.915s.914-.411.914-.915a.916.916 0 0 0-.914-.914zm3.657 0a.916.916 0 0 0-.914.914c0 .504.41.915.914.915s.915-.411.915-.915a.916.916 0 0 0-.915-.914zm3.657 0a.916.916 0 0 0-.914.914c0 .504.41.915.914.915s.915-.411.915-.915A.916.916 0 0 0 49.37 39zM14.63 49.971a.916.916 0 0 0-.915.915c0 .503.411.914.915.914.503 0 .914-.41.914-.914a.916.916 0 0 0-.914-.915zm3.657 0a.916.916 0 0 0-.915.915c0 .503.411.914.915.914.503 0 .914-.41.914-.914a.916.916 0 0 0-.914-.915zm3.657 0a.916.916 0 0 0-.914.915c0 .503.41.914.914.914.503 0 .914-.41.914-.914a.916.916 0 0 0-.914-.915zm3.657 0a.916.916 0 0 0-.914.915c0 .503.41.914.914.914s.914-.41.914-.914a.916.916 0 0 0-.914-.915zm3.657 0a.916.916 0 0 0-.914.915c0 .503.41.914.914.914s.914-.41.914-.914a.916.916 0 0 0-.914-.915zm3.657 0a.916.916 0 0 0-.914.915c0 .503.41.914.914.914s.915-.41.915-.914a.916.916 0 0 0-.915-.915zm3.657 0a.916.916 0 0 0-.914.915c0 .503.41.914.914.914s.915-.41.915-.914a.916.916 0 0 0-.915-.915zm3.658 0a.916.916 0 0 0-.915.915c0 .503.411.914.915.914.503 0 .914-.41.914-.914a.916.916 0 0 0-.914-.915zm3.657 0a.916.916 0 0 0-.915.915c0 .503.411.914.915.914.503 0 .914-.41.914-.914a.916.916 0 0 0-.914-.915zm3.657 0a.916.916 0 0 0-.914.915c0 .503.41.914.914.914.503 0 .914-.41.914-.914a.916.916 0 0 0-.914-.915zm3.657 0a.916.916 0 0 0-.914.915c0 .503.41.914.914.914s.914-.41.914-.914a.916.916 0 0 0-.914-.915zm3.657 0a.916.916 0 0 0-.914.915c0 .503.41.914.914.914s.914-.41.914-.914a.916.916 0 0 0-.914-.915zm3.657 0a.916.916 0 0 0-.914.915c0 .503.41.914.914.914s.915-.41.915-.914a.916.916 0 0 0-.915-.915z' }))),
        'cash': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', width: '64', height: '64', viewBox: '0 0 64 64' },
            React.createElement("path", { fill: 'currentColor', d: 'M0 6v45.714h.914c26.425 0 54.525 10.91 54.525 10.91l1.247.485v-8.66c2.074.515 3.398.885 3.398.885l1.173.346V44.4H64V6H0zm1.829 1.829H62.17V42.57H1.83V7.83zm10.057 1.828a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.657 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.657 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.657 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.657 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.657 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.658 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.657 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.657 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.657 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.657 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.657 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm.979 3.656a.914.914 0 1 0 0 1.828.914.914 0 0 0 0-1.828zm-42.188.003a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zM32 15.143c-5.544 0-10.057 4.513-10.057 10.057 0 5.544 4.513 10.057 10.057 10.057 5.544 0 10.057-4.513 10.057-10.057 0-5.544-4.513-10.057-10.057-10.057zm-23.773.848a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm47.543.002a.914.914 0 1 0 0 1.828.914.914 0 0 0 0-1.828zM4.57 16.97a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm27.429 0a8.215 8.215 0 0 1 8.229 8.229A8.215 8.215 0 0 1 32 33.429a8.215 8.215 0 0 1-8.229-8.229A8.215 8.215 0 0 1 32 16.971zm27.429 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zM4.57 20.63a.914.914 0 1 0 0 1.828.914.914 0 0 0 0-1.828zm54.858 0a.914.914 0 1 0 0 1.828.914.914 0 0 0 0-1.828zm-46.629.914A3.671 3.671 0 0 0 9.143 25.2a3.671 3.671 0 0 0 3.657 3.657 3.671 3.671 0 0 0 3.657-3.657 3.671 3.671 0 0 0-3.657-3.657zm37.486 0a3.671 3.671 0 0 0-3.657 3.657 3.671 3.671 0 0 0 3.657 3.657 3.671 3.671 0 0 0 3.657-3.657 3.671 3.671 0 0 0-3.657-3.657zM12.8 23.37c1.02 0 1.829.808 1.829 1.829 0 1.02-.808 1.829-1.829 1.829a1.815 1.815 0 0 1-1.829-1.829c0-1.02.808-1.829 1.829-1.829zm37.486 0c1.02 0 1.828.808 1.828 1.829 0 1.02-.808 1.829-1.828 1.829a1.815 1.815 0 0 1-1.829-1.829c0-1.02.808-1.829 1.829-1.829zm-45.715.915a.914.914 0 1 0 0 1.828.914.914 0 0 0 0-1.828zm54.858 0a.914.914 0 1 0 0 1.828.914.914 0 0 0 0-1.828zM4.57 27.943a.914.914 0 1 0 0 1.828.914.914 0 0 0 0-1.828zm54.858 0a.914.914 0 1 0 0 1.828.914.914 0 0 0 0-1.828zM4.57 31.6a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm54.858 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm-3.66.979a.914.914 0 1 0 0 1.828.914.914 0 0 0 0-1.828zm-47.542.001a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm2.677 2.675a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm42.189.004a.914.914 0 1 0 0 1.828.914.914 0 0 0 0-1.828zm-41.207 3.655a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.657 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.657 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.657 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.657 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.657 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.658 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.657 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.657 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.657 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.657 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm3.657 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zM1.83 44.4H59.429v8.877c-2.986-.84-25.604-6.903-57.6-7.025V44.4zm52.114 0a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829zm-1.829 2.743a.914.914 0 1 0 0 1.828.914.914 0 0 0 0-1.828zM1.83 48.07c19.849.075 36.317 2.523 46.628 4.562a.914.914 0 0 0 1.757.35c1.821.376 3.3.714 4.643 1.029v6.464C51.605 59.245 26.74 50.157 1.83 49.929v-1.86zm45.714 6.387a.914.914 0 1 0 0 1.829.914.914 0 0 0 0-1.829z' }))),
        'spinner': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', version: '1', width: '64', height: '64', viewBox: '0 0 128 128' },
            React.createElement("g", null,
                React.createElement("path", { d: 'M64 0a8 8 0 0 1 8 8c0 4.42-8 48.92-8 48.92S56 12.42 56 8a8 8 0 0 1 8-8z', fill: '#f9fbfb' }),
                React.createElement("path", { d: 'M64 0a8 8 0 0 1 8 8c0 4.42-8 48.92-8 48.92S56 12.42 56 8a8 8 0 0 1 8-8z', fill: '#ebf3f2', fillOpacity: '0.09', transform: 'rotate(30 64 64)' }),
                React.createElement("path", { d: 'M64 0a8 8 0 0 1 8 8c0 4.42-8 48.92-8 48.92S56 12.42 56 8a8 8 0 0 1 8-8z', fill: '#d9e8e8', fillOpacity: '0.17', transform: 'rotate(60 64 64)' }),
                React.createElement("path", { d: 'M64 0a8 8 0 0 1 8 8c0 4.42-8 48.92-8 48.92S56 12.42 56 8a8 8 0 0 1 8-8z', fill: '#c5dddc', fillOpacity: '0.25', transform: 'rotate(90 64 64)' }),
                React.createElement("path", { d: 'M64 0a8 8 0 0 1 8 8c0 4.42-8 48.92-8 48.92S56 12.42 56 8a8 8 0 0 1 8-8z', fill: '#b0d0ce', fillOpacity: '0.35', transform: 'rotate(120 64 64)' }),
                React.createElement("path", { d: 'M64 0a8 8 0 0 1 8 8c0 4.42-8 48.92-8 48.92S56 12.42 56 8a8 8 0 0 1 8-8z', fill: '#9bc3c1', fillOpacity: '0.44', transform: 'rotate(150 64 64)' }),
                React.createElement("path", { d: 'M64 0a8 8 0 0 1 8 8c0 4.42-8 48.92-8 48.92S56 12.42 56 8a8 8 0 0 1 8-8z', fill: '#83b5b3', fillOpacity: '0.55', transform: 'rotate(180 64 64)' }),
                React.createElement("path", { d: 'M64 0a8 8 0 0 1 8 8c0 4.42-8 48.92-8 48.92S56 12.42 56 8a8 8 0 0 1 8-8z', fill: '#6da8a5', fillOpacity: '0.65', transform: 'rotate(210 64 64)' }),
                React.createElement("path", { d: 'M64 0a8 8 0 0 1 8 8c0 4.42-8 48.92-8 48.92S56 12.42 56 8a8 8 0 0 1 8-8z', fill: '#579a97', fillOpacity: '0.75', transform: 'rotate(240 64 64)' }),
                React.createElement("path", { d: 'M64 0a8 8 0 0 1 8 8c0 4.42-8 48.92-8 48.92S56 12.42 56 8a8 8 0 0 1 8-8z', fill: '#428e8b', fillOpacity: '0.84', transform: 'rotate(270 64 64)' }),
                React.createElement("path", { d: 'M64 0a8 8 0 0 1 8 8c0 4.42-8 48.92-8 48.92S56 12.42 56 8a8 8 0 0 1 8-8z', fill: '#30837f', fillOpacity: '0.92', transform: 'rotate(300 64 64)' }),
                React.createElement("path", { d: 'M64 0a8 8 0 0 1 8 8c0 4.42-8 48.92-8 48.92S56 12.42 56 8a8 8 0 0 1 8-8z', fill: '#1D7874', transform: 'rotate(330 64 64)' }),
                React.createElement("animateTransform", { attributeName: 'transform', type: 'rotate', values: '0 64 64;30 64 64;60 64 64;90 64 64;120 64 64;150 64 64;180 64 64;210 64 64;240 64 64;270 64 64;300 64 64;330 64 64', calcMode: 'discrete', dur: '1080ms', repeatCount: 'indefinite' })))),
        'share': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '16', height: '16', viewBox: '0 0 16 16' },
            React.createElement("path", { fill: 'currentColor', d: 'M2 14.004C2 14.002 14 14 14 14c-.004 0 0-5.004 0-5.004a1 1 0 0 1 2 0v5.008C16 15.1 15.1 16 14 16H2c-1.106 0-2-.892-2-1.996V8.996a1 1 0 0 1 2 0v5.008zm2.706-8.272a.99.99 0 0 1-1.414 0 1.024 1.024 0 0 1 0-1.433L6.94.444A1.476 1.476 0 0 1 8 0c.4 0 .778.158 1.06.445L12.707 4.3c.39.394.39 1.036 0 1.432a.99.99 0 0 1-1.414 0L9 3.252v5.752a1 1 0 1 1-2 0V3.25L4.707 5.73l-.001.002z' }))),
        'doc': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', fillRule: 'evenodd', d: 'M6 24a3.002 3.002 0 0 1-3-3.012V3.012A3.008 3.008 0 0 1 6 0h8.25c.875.027 1.71.372 2.345.975l3.432 3.43c.6.636.945 1.47.975 2.345V21a3 3 0 0 1-3 3H6zm0-3h12V9h-3a3 3 0 0 1-3-3V3c-2.88 0-6 0-6 .009V21zm9-17.379V6h2.38L15 3.621z' }))),
        'phone': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M20.09 24a4 4 0 0 1-.398-.02 21.994 21.994 0 0 1-9.585-3.405 21.699 21.699 0 0 1-6.673-6.668A22.04 22.04 0 0 1 .016 4.234 3.884 3.884 0 0 1 3.882 0h3.04a3.888 3.888 0 0 1 3.886 3.358c.11.84.316 1.665.611 2.455a3.888 3.888 0 0 1-.881 4.105l-.25.25a14.459 14.459 0 0 0 3.503 3.504l.258-.258a3.883 3.883 0 0 1 4.093-.875c.795.296 1.62.502 2.476.615a3.88 3.88 0 0 1 3.341 3.907v3.041A3.884 3.884 0 0 1 20.091 24zm1.1-6.95a1.12 1.12 0 0 0-.95-1.153 14.012 14.012 0 0 1-3.068-.765A1.113 1.113 0 0 0 16 15.38l-1.294 1.294a.923.923 0 0 1-1.109.15 17.228 17.228 0 0 1-6.46-6.46.923.923 0 0 1 .15-1.11l1.29-1.29c.306-.31.404-.77.25-1.179-.37-.99-.625-2.018-.762-3.057A1.117 1.117 0 0 0 6.94 2.77H3.883a1.112 1.112 0 0 0-1.11 1.201 19.253 19.253 0 0 0 2.99 8.438 18.958 18.958 0 0 0 5.836 5.835 19.229 19.229 0 0 0 8.376 2.983 1.115 1.115 0 0 0 1.215-1.119V17.05z' }))),
        'wallet': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', width: '64', height: '64', viewBox: '0 0 64 64' },
            React.createElement("path", { fill: 'currentColor', d: 'M54.707 2.01C57.012 1.846 59 3.694 59 6.002v4.2c1.762.777 3 2.535 3 4.574v15.281c.594.352 1 .988 1 1.719v8c0 .73-.406 1.367-1 1.719v15.28c0 2.75-2.25 5-5 5H7c-2.75 0-5-2.25-5-5V8.71a3.08 3.08 0 0 1 2.86-3.062L54.706 2.01zm.148 1.996L5 7.64h-.004A1.06 1.06 0 0 0 4 8.709a1.05 1.05 0 0 0 1.066 1.067H57V6.002a1.984 1.984 0 0 0-2.145-1.996zM4 11.53v45.246c0 1.668 1.332 3 3 3h50c1.668 0 3-1.332 3-3v-15h-7c-2.95 0-5.3-2.192-5.797-5H47v-1c0-3.301 2.7-6 6-6h7v-15c0-1.668-1.332-3-3-3H5.066A2.46 2.46 0 0 1 4 11.53zm4 3.246c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm-48 4c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm48 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm-48 4c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm48 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm-48 4c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm48 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm-48 4c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm45 1c-2.219 0-4 1.781-4 4 0 2.219 1.781 4 4 4h8v-8h-8zm0 2c1.105 0 2 .894 2 2a1.999 1.999 0 1 1-4 0c0-1.106.895-2 2-2zm-45 1c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm0 4c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm0 4c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm48 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm-48 4c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm48 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm-48 4c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm48 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm-48 4c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zm4 0c.55 0 1 .449 1 1 0 .55-.45 1-1 1s-1-.45-1-1c0-.551.45-1 1-1zM35.8 40.88l2.586-.554s1.293-.114 1.463.966c0 0 .554 1.35-1.96 1.776l-2.529.426s-1.193.327-1.463-.966c0 0 .014-1.293.966-1.463l.938-.185zm-8.509-7.756c-.568-1.165.824-2.088.824-2.088 1.236-.98 2.23.426 2.23.426l2.614 4.219c.341-1.051.91-2.586.91-2.586.426-1.179 1.221-.426 1.221-.426l1.918 1.662.71-3.11c.512-2.416 1.35-2.359 1.35-2.359.824-.156 1.406.54 1.406.54.739.852.483 1.719.483 1.719l-1.633 7.06c-.228 1.577-1.18 1.009-1.18 1.009-.667-.228-2.5-2.074-2.5-2.074-.255-.341-.255-.086-.255-.086l-.796 2.671c-.724 1.86-2.315-.014-2.315-.014l-2.671-3.324a229.385 229.385 0 0 0-2.316-3.24zm-8.097-7.316c4.333-2.372 6.918 1.236 6.933 1.222.738.724.738 1.52.738 1.52.015 1.846-1.434 2.116-1.434 2.116-1.052.341-1.72-.753-1.72-.753-1.434-1.605-2.84-.78-2.84-.78-1.35.922.909 1.846 1.065 1.931.156.085 4.603 2.713 4.603 2.713 1.676 1.18 2.557 3.495 2.557 3.495 2.429 6.605-4.617 8.097-4.617 8.097-3.168.554-6.62-2.813-6.62-2.813-1.136-2.003 1.051-3.11 1.051-3.11.924-.498 1.35.127 1.35.127.014.213 2.017 1.62 2.017 1.62 1.449 1.292 2.642.426 2.642.426 1.279-.995.924-2.884.924-2.884-.128-2.202-6.52-4.915-6.52-4.915-1.464-.81-1.975-2.529-1.975-2.529-1.393-4.09 1.846-5.483 1.846-5.483z' }))),
        'web': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M20.991 19h-7.485a1.5 1.5 0 0 0 1.515 1.5h2.97a1.506 1.506 0 0 1 1.305.744c.27.462.27 1.035.006 1.5-.267.465-.76.753-1.296.756h-12a1.5 1.5 0 0 1-1.5-1.5 1.51 1.51 0 0 1 1.5-1.5h2.949c.4.005.786-.15 1.071-.435.285-.28.444-.664.444-1.065H3.01A3.012 3.012 0 0 1 0 16V4a3.002 3.002 0 0 1 3.012-3h17.973A3.01 3.01 0 0 1 24 4v12.015A3 3 0 0 1 20.991 19zm0-15H3.006l.01 12h17.991l-.015-12h-.001z' }))),
        'square-backspace': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', width: '48', height: '48', viewBox: '0 0 48 48' },
            React.createElement("path", { fill: 'currentColor', d: 'M4 24l12 16h28V8H16L4 24zM.879 21.879l13-17A3 3 0 0 1 16 4h29a3 3 0 0 1 3 3v34a3 3 0 0 1-3 3H16a3 3 0 0 1-2.121-.879l-13-17a3 3 0 0 1 0-4.242zM25.172 24l-5.657-5.657c-.586-.585-1.063-1.766 0-2.828 1.062-1.063 2.243-.586 2.828 0L28 21.172l5.657-5.657c.585-.586 1.768-1.06 2.828 0 1.06 1.06.586 2.243 0 2.828L30.828 24l5.657 5.657c.586.585 1.058 1.77 0 2.828-1.058 1.058-2.243.586-2.828 0L28 26.828l-5.657 5.657c-.585.586-1.768 1.06-2.828 0-1.06-1.06-.586-2.243 0-2.828L25.172 24z' }))),
        'return': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M8.59 20.94a1.485 1.485 0 0 1 0 2.121 1.534 1.534 0 0 1-2.147 0L.667 17.59A2.203 2.203 0 0 1 0 16c0-.6.237-1.167.666-1.59l5.775-5.47a1.538 1.538 0 0 1 2.151 0 1.488 1.488 0 0 1 0 2.12l-3.72 3.44H21V1.5c0-.883.668-1.5 1.5-1.5S24 .617 24 1.5v16H4.869l3.722 3.44z' }))),
        'repeat': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M23.334 7.587l-4.275 3.968c-.6.585-1.554.585-2.151 0a1.48 1.48 0 0 1-.444-1.06c0-.398.16-.78.444-1.06l2.21-1.93H3v3a1.5 1.5 0 1 1-3 0v-3c0-1.657 1.344-3 3-3l16.125-.01-2.217-1.934a1.488 1.488 0 0 1 0-2.122 1.536 1.536 0 0 1 2.15 0l4.274 3.968a2.23 2.23 0 0 1 .002 3.18zM4.95 12.44a1.536 1.536 0 0 1 2.15 0 1.483 1.483 0 0 1-.002 2.119l-2.22 1.935L21 16.506v-3a1.5 1.5 0 0 1 3 0v3a3 3 0 0 1-3 3H4.883l2.209 1.93a1.483 1.483 0 0 1 0 2.12 1.536 1.536 0 0 1-2.15 0L.667 19.588A2.224 2.224 0 0 1 0 17.998c0-.597.24-1.17.666-1.59L4.95 12.44z' }))),
        'smartphone': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M17 24H8a3 3 0 0 1-3-3V3a3 3 0 0 1 3-3h9a3 3 0 0 1 3 3v18a3 3 0 0 1-3 3zm0-19.5H8v15h9v-15z' }))),
        'text': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M10.5 21a1.5 1.5 0 0 0 0-3h-9a1.5 1.5 0 0 0 0 3h9zm12-7.5a1.5 1.5 0 0 0 0-3h-21a1.5 1.5 0 0 0 0 3h21zm-6-7.5a1.5 1.5 0 0 0 0-3h-15a1.5 1.5 0 0 0 0 3h15z' }))),
        'email': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '24', height: '24', viewBox: '0 0 24 24' },
            React.createElement("path", { fill: 'currentColor', d: 'M3.01 22a3 3 0 0 1-2.193-.95A3.005 3.005 0 0 1 0 19V5a3.002 3.002 0 0 1 3.012-3h17.977A3.013 3.013 0 0 1 24 5v14a3.002 3.002 0 0 1-3.012 3H3.011zM21 19V7.205l-7.418 7.635c-.42.425-.994.66-1.59.66-.6 0-1.173-.235-1.594-.66L3 7.226V19h18zM18.945 5H5.04l6.951 7.17L18.945 5z' }))),
        'change': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', width: '16', height: '16', viewBox: '0 0 16 16' },
            React.createElement("path", { fill: 'currentColor', fillRule: 'evenodd', d: 'M15.557 5.058l-2.85 2.645c-.4.39-1.036.39-1.434 0a.994.994 0 010-1.413l1.473-1.287H2v2a1 1 0 11-2 0v-2a2 2 0 012-2l10.751-.006-1.478-1.29a.992.992 0 010-1.414 1.024 1.024 0 011.433 0l2.85 2.645a1.486 1.486 0 01.001 2.12zM3.3 8.293a1.024 1.024 0 011.433 0 .989.989 0 010 1.413l-1.48 1.29L14 11.004v-2a1 1 0 012 0v2a2 2 0 01-2 2H3.255l1.473 1.288a.989.989 0 010 1.413c-.398.39-1.035.39-1.433 0L.445 13.06a1.483 1.483 0 01-.001-2.12L3.3 8.292z' }))),
        'more': (React.createElement("svg", { xmlns: 'http://www.w3.org/2000/svg', xmlnsXlink: 'http://www.w3.org/1999/xlink', width: '16', height: '16', viewBox: '0 0 16 16' },
            React.createElement("defs", null,
                React.createElement("path", { id: '7ce1975f-1487-43ce-94b1-0ed9361b2fd7', fill: 'currentColor', d: 'M14 4.222a2 2 0 10.001-3.999 2 2 0 00-.001 4zm-6 0A2 2 0 108.001.223a2 2 0 00-.001 4zm-6 0A2 2 0 102.001.223a2 2 0 00-.001 4z' })),
            React.createElement("use", { fillRule: 'evenodd', transform: 'translate(0 6)', xlinkHref: '#7ce1975f-1487-43ce-94b1-0ed9361b2fd7' }))),
    };
    UIDefaultIconFactory = UIDefaultIconFactory_1 = __decorate([
        inversify_1.injectable()
    ], UIDefaultIconFactory);
    return UIDefaultIconFactory;
}());
exports.UIDefaultIconFactory = UIDefaultIconFactory;
//# sourceMappingURL=ui-default-icon-factory.service.js.map